package muicm.diagram.providers;

import java.util.HashSet;
import java.util.IdentityHashMap;
import java.util.Map;
import java.util.Set;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.gmf.runtime.emf.type.core.ElementTypeRegistry;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.tooling.runtime.providers.DiagramElementTypeImages;
import org.eclipse.gmf.tooling.runtime.providers.DiagramElementTypes;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.graphics.Image;

import muicm.MuicmPackage;
import muicm.diagram.edit.parts.Calendar2EditPart;
import muicm.diagram.edit.parts.CalendarEditPart;
import muicm.diagram.edit.parts.CameraActionEditPart;
import muicm.diagram.edit.parts.CameraActionEventEditPart;
import muicm.diagram.edit.parts.Code2EditPart;
import muicm.diagram.edit.parts.CodeEditPart;
import muicm.diagram.edit.parts.DataBindingEditPart;
import muicm.diagram.edit.parts.DataBindingGroupEditPart;
import muicm.diagram.edit.parts.DataEditPart;
import muicm.diagram.edit.parts.DataFlowEditPart;
import muicm.diagram.edit.parts.DetailsEditPart;
import muicm.diagram.edit.parts.DynamicBehaviourEditPart;
import muicm.diagram.edit.parts.FormEditPart;
import muicm.diagram.edit.parts.IconEditPart;
import muicm.diagram.edit.parts.Label2EditPart;
import muicm.diagram.edit.parts.LabelEditPart;
import muicm.diagram.edit.parts.ListEditPart;
import muicm.diagram.edit.parts.LongPressEventEditPart;
import muicm.diagram.edit.parts.MInteractionFlowDataBindingGroupEditPart;
import muicm.diagram.edit.parts.MUICMEditPart;
import muicm.diagram.edit.parts.MViewComponent2EditPart;
import muicm.diagram.edit.parts.MViewComponentEditPart;
import muicm.diagram.edit.parts.MViewComponentPartEditPart;
import muicm.diagram.edit.parts.MViewElementEventEditPart;
import muicm.diagram.edit.parts.Map2EditPart;
import muicm.diagram.edit.parts.MapEditPart;
import muicm.diagram.edit.parts.MediaEditPart;
import muicm.diagram.edit.parts.MessageEditPart;
import muicm.diagram.edit.parts.MicrophoneActionEditPart;
import muicm.diagram.edit.parts.MicrophoneActionEventEditPart;
import muicm.diagram.edit.parts.NavigationFlowEditPart;
import muicm.diagram.edit.parts.OtherActionEditPart;
import muicm.diagram.edit.parts.OtherActionEventEditPart;
import muicm.diagram.edit.parts.PanEventEditPart;
import muicm.diagram.edit.parts.PinchEventEditPart;
import muicm.diagram.edit.parts.RotateEventEditPart;
import muicm.diagram.edit.parts.Screen2EditPart;
import muicm.diagram.edit.parts.ScreenEditPart;
import muicm.diagram.edit.parts.SearchViewEditPart;
import muicm.diagram.edit.parts.SelectionField2EditPart;
import muicm.diagram.edit.parts.SelectionFieldEditPart;
import muicm.diagram.edit.parts.SimpleField2EditPart;
import muicm.diagram.edit.parts.SimpleFieldEditPart;
import muicm.diagram.edit.parts.StaticContent2EditPart;
import muicm.diagram.edit.parts.StaticContentEditPart;
import muicm.diagram.edit.parts.SwipeEventEditPart;
import muicm.diagram.edit.parts.TapEventEditPart;
import muicm.diagram.edit.parts.TextBox2EditPart;
import muicm.diagram.edit.parts.TextBoxEditPart;
import muicm.diagram.edit.parts.ToolBarEditPart;
import muicm.diagram.edit.parts.TouchEventEditPart;
import muicm.diagram.edit.parts.UtilityViewEditPart;
import muicm.diagram.part.MuicmDiagramEditorPlugin;

/**
 * @generated
 */
public class MuicmElementTypes {

	/**
	* @generated
	*/
	private MuicmElementTypes() {
	}

	/**
	* @generated
	*/
	private static Map<IElementType, ENamedElement> elements;

	/**
	* @generated
	*/
	private static DiagramElementTypeImages elementTypeImages = new DiagramElementTypeImages(
			MuicmDiagramEditorPlugin.getInstance().getItemProvidersAdapterFactory());

	/**
	* @generated
	*/
	private static Set<IElementType> KNOWN_ELEMENT_TYPES;

	/**
	* @generated
	*/
	public static final IElementType MUICM_1000 = getElementType("muicm.diagram.MUICM_1000"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType Screen_2001 = getElementType("muicm.diagram.Screen_2001"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType MViewComponent_2002 = getElementType("muicm.diagram.MViewComponent_2002"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType OtherAction_2003 = getElementType("muicm.diagram.OtherAction_2003"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType CameraAction_2004 = getElementType("muicm.diagram.CameraAction_2004"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType MicrophoneAction_2005 = getElementType("muicm.diagram.MicrophoneAction_2005"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType DataBindingGroup_2006 = getElementType("muicm.diagram.DataBindingGroup_2006"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType Screen_3001 = getElementType("muicm.diagram.Screen_3001"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType MViewComponent_3002 = getElementType("muicm.diagram.MViewComponent_3002"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType Label_3021 = getElementType("muicm.diagram.Label_3021"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType TextBox_3022 = getElementType("muicm.diagram.TextBox_3022"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType Map_3023 = getElementType("muicm.diagram.Map_3023"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType Calendar_3024 = getElementType("muicm.diagram.Calendar_3024"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType Code_3025 = getElementType("muicm.diagram.Code_3025"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType SimpleField_3026 = getElementType("muicm.diagram.SimpleField_3026"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType SelectionField_3027 = getElementType("muicm.diagram.SelectionField_3027"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType SwipeEvent_3014 = getElementType("muicm.diagram.SwipeEvent_3014"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType TapEvent_3015 = getElementType("muicm.diagram.TapEvent_3015"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType TouchEvent_3016 = getElementType("muicm.diagram.TouchEvent_3016"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType PanEvent_3011 = getElementType("muicm.diagram.PanEvent_3011"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType PinchEvent_3012 = getElementType("muicm.diagram.PinchEvent_3012"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType RotateEvent_3013 = getElementType("muicm.diagram.RotateEvent_3013"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType MViewElementEvent_3028 = getElementType("muicm.diagram.MViewElementEvent_3028"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType MViewComponentPart_3029 = getElementType("muicm.diagram.MViewComponentPart_3029"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType StaticContent_3030 = getElementType("muicm.diagram.StaticContent_3030"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType DynamicBehaviour_3031 = getElementType("muicm.diagram.DynamicBehaviour_3031"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType Media_3042 = getElementType("muicm.diagram.Media_3042"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType Form_3003 = getElementType("muicm.diagram.Form_3003"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType Data_3032 = getElementType("muicm.diagram.Data_3032"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType SimpleField_3033 = getElementType("muicm.diagram.SimpleField_3033"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType SelectionField_3034 = getElementType("muicm.diagram.SelectionField_3034"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType Label_3035 = getElementType("muicm.diagram.Label_3035"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType List_3004 = getElementType("muicm.diagram.List_3004"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType Details_3005 = getElementType("muicm.diagram.Details_3005"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType TextBox_3036 = getElementType("muicm.diagram.TextBox_3036"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType StaticContent_3037 = getElementType("muicm.diagram.StaticContent_3037"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType Message_3006 = getElementType("muicm.diagram.Message_3006"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType UtilityView_3007 = getElementType("muicm.diagram.UtilityView_3007"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType Map_3038 = getElementType("muicm.diagram.Map_3038"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType Code_3039 = getElementType("muicm.diagram.Code_3039"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType Calendar_3040 = getElementType("muicm.diagram.Calendar_3040"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType SearchView_3008 = getElementType("muicm.diagram.SearchView_3008"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType ToolBar_3009 = getElementType("muicm.diagram.ToolBar_3009"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType Icon_3041 = getElementType("muicm.diagram.Icon_3041"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType LongPressEvent_3010 = getElementType("muicm.diagram.LongPressEvent_3010"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType OtherActionEvent_3017 = getElementType("muicm.diagram.OtherActionEvent_3017"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType CameraActionEvent_3018 = getElementType("muicm.diagram.CameraActionEvent_3018"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType MicrophoneActionEvent_3019 = getElementType(
			"muicm.diagram.MicrophoneActionEvent_3019"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType DataBinding_3020 = getElementType("muicm.diagram.DataBinding_3020"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType MInteractionFlowDataBindingGroup_4001 = getElementType(
			"muicm.diagram.MInteractionFlowDataBindingGroup_4001"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType NavigationFlow_4002 = getElementType("muicm.diagram.NavigationFlow_4002"); //$NON-NLS-1$
	/**
	* @generated
	*/
	public static final IElementType DataFlow_4003 = getElementType("muicm.diagram.DataFlow_4003"); //$NON-NLS-1$

	/**
	* @generated
	*/
	public static ImageDescriptor getImageDescriptor(ENamedElement element) {
		return elementTypeImages.getImageDescriptor(element);
	}

	/**
	* @generated
	*/
	public static Image getImage(ENamedElement element) {
		return elementTypeImages.getImage(element);
	}

	/**
	* @generated
	*/
	public static ImageDescriptor getImageDescriptor(IAdaptable hint) {
		return getImageDescriptor(getElement(hint));
	}

	/**
	* @generated
	*/
	public static Image getImage(IAdaptable hint) {
		return getImage(getElement(hint));
	}

	/**
	* Returns 'type' of the ecore object associated with the hint.
	* 
	* @generated
	*/
	public static ENamedElement getElement(IAdaptable hint) {
		Object type = hint.getAdapter(IElementType.class);
		if (elements == null) {
			elements = new IdentityHashMap<IElementType, ENamedElement>();

			elements.put(MUICM_1000, MuicmPackage.eINSTANCE.getMUICM());

			elements.put(Screen_2001, MuicmPackage.eINSTANCE.getScreen());

			elements.put(MViewComponent_2002, MuicmPackage.eINSTANCE.getMViewComponent());

			elements.put(OtherAction_2003, MuicmPackage.eINSTANCE.getOtherAction());

			elements.put(CameraAction_2004, MuicmPackage.eINSTANCE.getCameraAction());

			elements.put(MicrophoneAction_2005, MuicmPackage.eINSTANCE.getMicrophoneAction());

			elements.put(DataBindingGroup_2006, MuicmPackage.eINSTANCE.getDataBindingGroup());

			elements.put(Screen_3001, MuicmPackage.eINSTANCE.getScreen());

			elements.put(MViewComponent_3002, MuicmPackage.eINSTANCE.getMViewComponent());

			elements.put(Label_3021, MuicmPackage.eINSTANCE.getLabel());

			elements.put(TextBox_3022, MuicmPackage.eINSTANCE.getTextBox());

			elements.put(Map_3023, MuicmPackage.eINSTANCE.getMap());

			elements.put(Calendar_3024, MuicmPackage.eINSTANCE.getCalendar());

			elements.put(Code_3025, MuicmPackage.eINSTANCE.getCode());

			elements.put(SimpleField_3026, MuicmPackage.eINSTANCE.getSimpleField());

			elements.put(SelectionField_3027, MuicmPackage.eINSTANCE.getSelectionField());

			elements.put(SwipeEvent_3014, MuicmPackage.eINSTANCE.getSwipeEvent());

			elements.put(TapEvent_3015, MuicmPackage.eINSTANCE.getTapEvent());

			elements.put(TouchEvent_3016, MuicmPackage.eINSTANCE.getTouchEvent());

			elements.put(PanEvent_3011, MuicmPackage.eINSTANCE.getPanEvent());

			elements.put(PinchEvent_3012, MuicmPackage.eINSTANCE.getPinchEvent());

			elements.put(RotateEvent_3013, MuicmPackage.eINSTANCE.getRotateEvent());

			elements.put(MViewElementEvent_3028, MuicmPackage.eINSTANCE.getMViewElementEvent());

			elements.put(MViewComponentPart_3029, MuicmPackage.eINSTANCE.getMViewComponentPart());

			elements.put(StaticContent_3030, MuicmPackage.eINSTANCE.getStaticContent());

			elements.put(DynamicBehaviour_3031, MuicmPackage.eINSTANCE.getDynamicBehaviour());

			elements.put(Media_3042, MuicmPackage.eINSTANCE.getMedia());

			elements.put(Form_3003, MuicmPackage.eINSTANCE.getForm());

			elements.put(Data_3032, MuicmPackage.eINSTANCE.getData());

			elements.put(SimpleField_3033, MuicmPackage.eINSTANCE.getSimpleField());

			elements.put(SelectionField_3034, MuicmPackage.eINSTANCE.getSelectionField());

			elements.put(Label_3035, MuicmPackage.eINSTANCE.getLabel());

			elements.put(List_3004, MuicmPackage.eINSTANCE.getList());

			elements.put(Details_3005, MuicmPackage.eINSTANCE.getDetails());

			elements.put(TextBox_3036, MuicmPackage.eINSTANCE.getTextBox());

			elements.put(StaticContent_3037, MuicmPackage.eINSTANCE.getStaticContent());

			elements.put(Message_3006, MuicmPackage.eINSTANCE.getMessage());

			elements.put(UtilityView_3007, MuicmPackage.eINSTANCE.getUtilityView());

			elements.put(Map_3038, MuicmPackage.eINSTANCE.getMap());

			elements.put(Code_3039, MuicmPackage.eINSTANCE.getCode());

			elements.put(Calendar_3040, MuicmPackage.eINSTANCE.getCalendar());

			elements.put(SearchView_3008, MuicmPackage.eINSTANCE.getSearchView());

			elements.put(ToolBar_3009, MuicmPackage.eINSTANCE.getToolBar());

			elements.put(Icon_3041, MuicmPackage.eINSTANCE.getIcon());

			elements.put(LongPressEvent_3010, MuicmPackage.eINSTANCE.getLongPressEvent());

			elements.put(OtherActionEvent_3017, MuicmPackage.eINSTANCE.getOtherActionEvent());

			elements.put(CameraActionEvent_3018, MuicmPackage.eINSTANCE.getCameraActionEvent());

			elements.put(MicrophoneActionEvent_3019, MuicmPackage.eINSTANCE.getMicrophoneActionEvent());

			elements.put(DataBinding_3020, MuicmPackage.eINSTANCE.getDataBinding());

			elements.put(MInteractionFlowDataBindingGroup_4001,
					MuicmPackage.eINSTANCE.getMInteractionFlow_DataBindingGroup());

			elements.put(NavigationFlow_4002, MuicmPackage.eINSTANCE.getNavigationFlow());

			elements.put(DataFlow_4003, MuicmPackage.eINSTANCE.getDataFlow());
		}
		return (ENamedElement) elements.get(type);
	}

	/**
	* @generated
	*/
	private static IElementType getElementType(String id) {
		return ElementTypeRegistry.getInstance().getType(id);
	}

	/**
	* @generated
	*/
	public static boolean isKnownElementType(IElementType elementType) {
		if (KNOWN_ELEMENT_TYPES == null) {
			KNOWN_ELEMENT_TYPES = new HashSet<IElementType>();
			KNOWN_ELEMENT_TYPES.add(MUICM_1000);
			KNOWN_ELEMENT_TYPES.add(Screen_2001);
			KNOWN_ELEMENT_TYPES.add(MViewComponent_2002);
			KNOWN_ELEMENT_TYPES.add(OtherAction_2003);
			KNOWN_ELEMENT_TYPES.add(CameraAction_2004);
			KNOWN_ELEMENT_TYPES.add(MicrophoneAction_2005);
			KNOWN_ELEMENT_TYPES.add(DataBindingGroup_2006);
			KNOWN_ELEMENT_TYPES.add(Screen_3001);
			KNOWN_ELEMENT_TYPES.add(MViewComponent_3002);
			KNOWN_ELEMENT_TYPES.add(Label_3021);
			KNOWN_ELEMENT_TYPES.add(TextBox_3022);
			KNOWN_ELEMENT_TYPES.add(Map_3023);
			KNOWN_ELEMENT_TYPES.add(Calendar_3024);
			KNOWN_ELEMENT_TYPES.add(Code_3025);
			KNOWN_ELEMENT_TYPES.add(SimpleField_3026);
			KNOWN_ELEMENT_TYPES.add(SelectionField_3027);
			KNOWN_ELEMENT_TYPES.add(SwipeEvent_3014);
			KNOWN_ELEMENT_TYPES.add(TapEvent_3015);
			KNOWN_ELEMENT_TYPES.add(TouchEvent_3016);
			KNOWN_ELEMENT_TYPES.add(PanEvent_3011);
			KNOWN_ELEMENT_TYPES.add(PinchEvent_3012);
			KNOWN_ELEMENT_TYPES.add(RotateEvent_3013);
			KNOWN_ELEMENT_TYPES.add(MViewElementEvent_3028);
			KNOWN_ELEMENT_TYPES.add(MViewComponentPart_3029);
			KNOWN_ELEMENT_TYPES.add(StaticContent_3030);
			KNOWN_ELEMENT_TYPES.add(DynamicBehaviour_3031);
			KNOWN_ELEMENT_TYPES.add(Media_3042);
			KNOWN_ELEMENT_TYPES.add(Form_3003);
			KNOWN_ELEMENT_TYPES.add(Data_3032);
			KNOWN_ELEMENT_TYPES.add(SimpleField_3033);
			KNOWN_ELEMENT_TYPES.add(SelectionField_3034);
			KNOWN_ELEMENT_TYPES.add(Label_3035);
			KNOWN_ELEMENT_TYPES.add(List_3004);
			KNOWN_ELEMENT_TYPES.add(Details_3005);
			KNOWN_ELEMENT_TYPES.add(TextBox_3036);
			KNOWN_ELEMENT_TYPES.add(StaticContent_3037);
			KNOWN_ELEMENT_TYPES.add(Message_3006);
			KNOWN_ELEMENT_TYPES.add(UtilityView_3007);
			KNOWN_ELEMENT_TYPES.add(Map_3038);
			KNOWN_ELEMENT_TYPES.add(Code_3039);
			KNOWN_ELEMENT_TYPES.add(Calendar_3040);
			KNOWN_ELEMENT_TYPES.add(SearchView_3008);
			KNOWN_ELEMENT_TYPES.add(ToolBar_3009);
			KNOWN_ELEMENT_TYPES.add(Icon_3041);
			KNOWN_ELEMENT_TYPES.add(LongPressEvent_3010);
			KNOWN_ELEMENT_TYPES.add(OtherActionEvent_3017);
			KNOWN_ELEMENT_TYPES.add(CameraActionEvent_3018);
			KNOWN_ELEMENT_TYPES.add(MicrophoneActionEvent_3019);
			KNOWN_ELEMENT_TYPES.add(DataBinding_3020);
			KNOWN_ELEMENT_TYPES.add(MInteractionFlowDataBindingGroup_4001);
			KNOWN_ELEMENT_TYPES.add(NavigationFlow_4002);
			KNOWN_ELEMENT_TYPES.add(DataFlow_4003);
		}
		return KNOWN_ELEMENT_TYPES.contains(elementType);
	}

	/**
	* @generated
	*/
	public static IElementType getElementType(int visualID) {
		switch (visualID) {
		case MUICMEditPart.VISUAL_ID:
			return MUICM_1000;
		case ScreenEditPart.VISUAL_ID:
			return Screen_2001;
		case MViewComponentEditPart.VISUAL_ID:
			return MViewComponent_2002;
		case OtherActionEditPart.VISUAL_ID:
			return OtherAction_2003;
		case CameraActionEditPart.VISUAL_ID:
			return CameraAction_2004;
		case MicrophoneActionEditPart.VISUAL_ID:
			return MicrophoneAction_2005;
		case DataBindingGroupEditPart.VISUAL_ID:
			return DataBindingGroup_2006;
		case Screen2EditPart.VISUAL_ID:
			return Screen_3001;
		case MViewComponent2EditPart.VISUAL_ID:
			return MViewComponent_3002;
		case LabelEditPart.VISUAL_ID:
			return Label_3021;
		case TextBoxEditPart.VISUAL_ID:
			return TextBox_3022;
		case MapEditPart.VISUAL_ID:
			return Map_3023;
		case CalendarEditPart.VISUAL_ID:
			return Calendar_3024;
		case CodeEditPart.VISUAL_ID:
			return Code_3025;
		case SimpleFieldEditPart.VISUAL_ID:
			return SimpleField_3026;
		case SelectionFieldEditPart.VISUAL_ID:
			return SelectionField_3027;
		case SwipeEventEditPart.VISUAL_ID:
			return SwipeEvent_3014;
		case TapEventEditPart.VISUAL_ID:
			return TapEvent_3015;
		case TouchEventEditPart.VISUAL_ID:
			return TouchEvent_3016;
		case PanEventEditPart.VISUAL_ID:
			return PanEvent_3011;
		case PinchEventEditPart.VISUAL_ID:
			return PinchEvent_3012;
		case RotateEventEditPart.VISUAL_ID:
			return RotateEvent_3013;
		case MViewElementEventEditPart.VISUAL_ID:
			return MViewElementEvent_3028;
		case MViewComponentPartEditPart.VISUAL_ID:
			return MViewComponentPart_3029;
		case StaticContentEditPart.VISUAL_ID:
			return StaticContent_3030;
		case DynamicBehaviourEditPart.VISUAL_ID:
			return DynamicBehaviour_3031;
		case MediaEditPart.VISUAL_ID:
			return Media_3042;
		case FormEditPart.VISUAL_ID:
			return Form_3003;
		case DataEditPart.VISUAL_ID:
			return Data_3032;
		case SimpleField2EditPart.VISUAL_ID:
			return SimpleField_3033;
		case SelectionField2EditPart.VISUAL_ID:
			return SelectionField_3034;
		case Label2EditPart.VISUAL_ID:
			return Label_3035;
		case ListEditPart.VISUAL_ID:
			return List_3004;
		case DetailsEditPart.VISUAL_ID:
			return Details_3005;
		case TextBox2EditPart.VISUAL_ID:
			return TextBox_3036;
		case StaticContent2EditPart.VISUAL_ID:
			return StaticContent_3037;
		case MessageEditPart.VISUAL_ID:
			return Message_3006;
		case UtilityViewEditPart.VISUAL_ID:
			return UtilityView_3007;
		case Map2EditPart.VISUAL_ID:
			return Map_3038;
		case Code2EditPart.VISUAL_ID:
			return Code_3039;
		case Calendar2EditPart.VISUAL_ID:
			return Calendar_3040;
		case SearchViewEditPart.VISUAL_ID:
			return SearchView_3008;
		case ToolBarEditPart.VISUAL_ID:
			return ToolBar_3009;
		case IconEditPart.VISUAL_ID:
			return Icon_3041;
		case LongPressEventEditPart.VISUAL_ID:
			return LongPressEvent_3010;
		case OtherActionEventEditPart.VISUAL_ID:
			return OtherActionEvent_3017;
		case CameraActionEventEditPart.VISUAL_ID:
			return CameraActionEvent_3018;
		case MicrophoneActionEventEditPart.VISUAL_ID:
			return MicrophoneActionEvent_3019;
		case DataBindingEditPart.VISUAL_ID:
			return DataBinding_3020;
		case MInteractionFlowDataBindingGroupEditPart.VISUAL_ID:
			return MInteractionFlowDataBindingGroup_4001;
		case NavigationFlowEditPart.VISUAL_ID:
			return NavigationFlow_4002;
		case DataFlowEditPart.VISUAL_ID:
			return DataFlow_4003;
		}
		return null;
	}

	/**
	* @generated
	*/
	public static final DiagramElementTypes TYPED_INSTANCE = new DiagramElementTypes(elementTypeImages) {

		/**
		* @generated
		*/
		@Override

		public boolean isKnownElementType(IElementType elementType) {
			return muicm.diagram.providers.MuicmElementTypes.isKnownElementType(elementType);
		}

		/**
		* @generated
		*/
		@Override

		public IElementType getElementTypeForVisualId(int visualID) {
			return muicm.diagram.providers.MuicmElementTypes.getElementType(visualID);
		}

		/**
		* @generated
		*/
		@Override

		public ENamedElement getDefiningNamedElement(IAdaptable elementTypeAdapter) {
			return muicm.diagram.providers.MuicmElementTypes.getElement(elementTypeAdapter);
		}
	};

}
