package muicm.diagram.providers;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.gmf.runtime.common.core.service.AbstractProvider;
import org.eclipse.gmf.runtime.common.core.service.IOperation;
import org.eclipse.gmf.runtime.common.ui.services.parser.GetParserOperation;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParserProvider;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserService;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.emf.ui.services.parser.ParserHintAdapter;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.tooling.runtime.parsers.ChoiceParserBase;
import org.eclipse.gmf.tooling.runtime.parsers.OclChoiceParser;

import muicm.MuicmPackage;
import muicm.diagram.edit.parts.CalendarName2EditPart;
import muicm.diagram.edit.parts.CalendarNameEditPart;
import muicm.diagram.edit.parts.CameraActionEventNameEditPart;
import muicm.diagram.edit.parts.CameraActionNameEditPart;
import muicm.diagram.edit.parts.CodeName2EditPart;
import muicm.diagram.edit.parts.CodeNameEditPart;
import muicm.diagram.edit.parts.DataBindingGroupNameEditPart;
import muicm.diagram.edit.parts.DataBindingSourceDataEditPart;
import muicm.diagram.edit.parts.DataBindingTargetDataEditPart;
import muicm.diagram.edit.parts.DataFlowNameEditPart;
import muicm.diagram.edit.parts.DataNameEditPart;
import muicm.diagram.edit.parts.DetailsNameEditPart;
import muicm.diagram.edit.parts.DynamicBehaviourNameEditPart;
import muicm.diagram.edit.parts.FormNameEditPart;
import muicm.diagram.edit.parts.IconNameEditPart;
import muicm.diagram.edit.parts.LabelName2EditPart;
import muicm.diagram.edit.parts.LabelNameEditPart;
import muicm.diagram.edit.parts.ListNameEditPart;
import muicm.diagram.edit.parts.LongPressEventNameEditPart;
import muicm.diagram.edit.parts.MViewComponentName2EditPart;
import muicm.diagram.edit.parts.MViewComponentNameEditPart;
import muicm.diagram.edit.parts.MViewComponentPartNameEditPart;
import muicm.diagram.edit.parts.MViewElementEventNameEditPart;
import muicm.diagram.edit.parts.MapName2EditPart;
import muicm.diagram.edit.parts.MapNameEditPart;
import muicm.diagram.edit.parts.MediaNameEditPart;
import muicm.diagram.edit.parts.MessageNameEditPart;
import muicm.diagram.edit.parts.MicrophoneActionEventNameEditPart;
import muicm.diagram.edit.parts.MicrophoneActionNameEditPart;
import muicm.diagram.edit.parts.NavigationFlowNameEditPart;
import muicm.diagram.edit.parts.OtherActionEventNameEditPart;
import muicm.diagram.edit.parts.OtherActionNameEditPart;
import muicm.diagram.edit.parts.PanEventNameEditPart;
import muicm.diagram.edit.parts.PinchEventNameEditPart;
import muicm.diagram.edit.parts.RotateEventNameEditPart;
import muicm.diagram.edit.parts.ScreenName2EditPart;
import muicm.diagram.edit.parts.ScreenNameEditPart;
import muicm.diagram.edit.parts.SearchViewNameEditPart;
import muicm.diagram.edit.parts.SelectionFieldName2EditPart;
import muicm.diagram.edit.parts.SelectionFieldNameEditPart;
import muicm.diagram.edit.parts.SimpleFieldName2EditPart;
import muicm.diagram.edit.parts.SimpleFieldNameEditPart;
import muicm.diagram.edit.parts.StaticContentName2EditPart;
import muicm.diagram.edit.parts.StaticContentNameEditPart;
import muicm.diagram.edit.parts.SwipeEventNameEditPart;
import muicm.diagram.edit.parts.TapEventNameEditPart;
import muicm.diagram.edit.parts.TextBoxName2EditPart;
import muicm.diagram.edit.parts.TextBoxNameEditPart;
import muicm.diagram.edit.parts.ToolBarNameEditPart;
import muicm.diagram.edit.parts.TouchEventNameEditPart;
import muicm.diagram.edit.parts.UtilityViewNameEditPart;
import muicm.diagram.parsers.MessageFormatParser;
import muicm.diagram.part.MuicmDiagramEditorPlugin;
import muicm.diagram.part.MuicmVisualIDRegistry;

/**
 * @generated
 */
public class MuicmParserProvider extends AbstractProvider implements IParserProvider {

	/**
	* @generated
	*/
	private IParser screenName_5017Parser;

	/**
	* @generated
	*/
	private IParser getScreenName_5017Parser() {
		if (screenName_5017Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			screenName_5017Parser = parser;
		}
		return screenName_5017Parser;
	}

	/**
	* @generated
	*/
	private IParser mViewComponentName_5018Parser;

	/**
	* @generated
	*/
	private IParser getMViewComponentName_5018Parser() {
		if (mViewComponentName_5018Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			mViewComponentName_5018Parser = parser;
		}
		return mViewComponentName_5018Parser;
	}

	/**
	* @generated
	*/
	private IParser otherActionName_5020Parser;

	/**
	* @generated
	*/
	private IParser getOtherActionName_5020Parser() {
		if (otherActionName_5020Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			otherActionName_5020Parser = parser;
		}
		return otherActionName_5020Parser;
	}

	/**
	* @generated
	*/
	private IParser cameraActionName_5022Parser;

	/**
	* @generated
	*/
	private IParser getCameraActionName_5022Parser() {
		if (cameraActionName_5022Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			cameraActionName_5022Parser = parser;
		}
		return cameraActionName_5022Parser;
	}

	/**
	* @generated
	*/
	private IParser microphoneActionName_5024Parser;

	/**
	* @generated
	*/
	private IParser getMicrophoneActionName_5024Parser() {
		if (microphoneActionName_5024Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			microphoneActionName_5024Parser = parser;
		}
		return microphoneActionName_5024Parser;
	}

	/**
	* @generated
	*/
	private IParser dataBindingGroupName_5025Parser;

	/**
	* @generated
	*/
	private IParser getDataBindingGroupName_5025Parser() {
		if (dataBindingGroupName_5025Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			dataBindingGroupName_5025Parser = parser;
		}
		return dataBindingGroupName_5025Parser;
	}

	/**
	* @generated
	*/
	private IParser screenName_5016Parser;

	/**
	* @generated
	*/
	private IParser getScreenName_5016Parser() {
		if (screenName_5016Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			screenName_5016Parser = parser;
		}
		return screenName_5016Parser;
	}

	/**
	* @generated
	*/
	private IParser mViewComponentName_5001Parser;

	/**
	* @generated
	*/
	private IParser getMViewComponentName_5001Parser() {
		if (mViewComponentName_5001Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			mViewComponentName_5001Parser = parser;
		}
		return mViewComponentName_5001Parser;
	}

	/**
	* @generated
	*/
	private IParser labelName_5026Parser;

	/**
	* @generated
	*/
	private IParser getLabelName_5026Parser() {
		if (labelName_5026Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			labelName_5026Parser = parser;
		}
		return labelName_5026Parser;
	}

	/**
	* @generated
	*/
	private IParser textBoxName_5027Parser;

	/**
	* @generated
	*/
	private IParser getTextBoxName_5027Parser() {
		if (textBoxName_5027Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			textBoxName_5027Parser = parser;
		}
		return textBoxName_5027Parser;
	}

	/**
	* @generated
	*/
	private IParser mapName_5028Parser;

	/**
	* @generated
	*/
	private IParser getMapName_5028Parser() {
		if (mapName_5028Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			mapName_5028Parser = parser;
		}
		return mapName_5028Parser;
	}

	/**
	* @generated
	*/
	private IParser calendarName_5029Parser;

	/**
	* @generated
	*/
	private IParser getCalendarName_5029Parser() {
		if (calendarName_5029Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			calendarName_5029Parser = parser;
		}
		return calendarName_5029Parser;
	}

	/**
	* @generated
	*/
	private IParser codeName_5030Parser;

	/**
	* @generated
	*/
	private IParser getCodeName_5030Parser() {
		if (codeName_5030Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			codeName_5030Parser = parser;
		}
		return codeName_5030Parser;
	}

	/**
	* @generated
	*/
	private IParser simpleFieldName_5031Parser;

	/**
	* @generated
	*/
	private IParser getSimpleFieldName_5031Parser() {
		if (simpleFieldName_5031Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			simpleFieldName_5031Parser = parser;
		}
		return simpleFieldName_5031Parser;
	}

	/**
	* @generated
	*/
	private IParser selectionFieldName_5032Parser;

	/**
	* @generated
	*/
	private IParser getSelectionFieldName_5032Parser() {
		if (selectionFieldName_5032Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			selectionFieldName_5032Parser = parser;
		}
		return selectionFieldName_5032Parser;
	}

	/**
	* @generated
	*/
	private IParser swipeEventName_5013Parser;

	/**
	* @generated
	*/
	private IParser getSwipeEventName_5013Parser() {
		if (swipeEventName_5013Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			swipeEventName_5013Parser = parser;
		}
		return swipeEventName_5013Parser;
	}

	/**
	* @generated
	*/
	private IParser tapEventName_5014Parser;

	/**
	* @generated
	*/
	private IParser getTapEventName_5014Parser() {
		if (tapEventName_5014Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			tapEventName_5014Parser = parser;
		}
		return tapEventName_5014Parser;
	}

	/**
	* @generated
	*/
	private IParser touchEventName_5015Parser;

	/**
	* @generated
	*/
	private IParser getTouchEventName_5015Parser() {
		if (touchEventName_5015Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			touchEventName_5015Parser = parser;
		}
		return touchEventName_5015Parser;
	}

	/**
	* @generated
	*/
	private IParser panEventName_5010Parser;

	/**
	* @generated
	*/
	private IParser getPanEventName_5010Parser() {
		if (panEventName_5010Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			panEventName_5010Parser = parser;
		}
		return panEventName_5010Parser;
	}

	/**
	* @generated
	*/
	private IParser pinchEventName_5011Parser;

	/**
	* @generated
	*/
	private IParser getPinchEventName_5011Parser() {
		if (pinchEventName_5011Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			pinchEventName_5011Parser = parser;
		}
		return pinchEventName_5011Parser;
	}

	/**
	* @generated
	*/
	private IParser rotateEventName_5012Parser;

	/**
	* @generated
	*/
	private IParser getRotateEventName_5012Parser() {
		if (rotateEventName_5012Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			rotateEventName_5012Parser = parser;
		}
		return rotateEventName_5012Parser;
	}

	/**
	* @generated
	*/
	private IParser mViewElementEventName_5033Parser;

	/**
	* @generated
	*/
	private IParser getMViewElementEventName_5033Parser() {
		if (mViewElementEventName_5033Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			mViewElementEventName_5033Parser = parser;
		}
		return mViewElementEventName_5033Parser;
	}

	/**
	* @generated
	*/
	private IParser mViewComponentPartName_5034Parser;

	/**
	* @generated
	*/
	private IParser getMViewComponentPartName_5034Parser() {
		if (mViewComponentPartName_5034Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			mViewComponentPartName_5034Parser = parser;
		}
		return mViewComponentPartName_5034Parser;
	}

	/**
	* @generated
	*/
	private IParser staticContentName_5035Parser;

	/**
	* @generated
	*/
	private IParser getStaticContentName_5035Parser() {
		if (staticContentName_5035Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			staticContentName_5035Parser = parser;
		}
		return staticContentName_5035Parser;
	}

	/**
	* @generated
	*/
	private IParser dynamicBehaviourName_5036Parser;

	/**
	* @generated
	*/
	private IParser getDynamicBehaviourName_5036Parser() {
		if (dynamicBehaviourName_5036Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			dynamicBehaviourName_5036Parser = parser;
		}
		return dynamicBehaviourName_5036Parser;
	}

	/**
	* @generated
	*/
	private IParser mediaName_5049Parser;

	/**
	* @generated
	*/
	private IParser getMediaName_5049Parser() {
		if (mediaName_5049Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			mediaName_5049Parser = parser;
		}
		return mediaName_5049Parser;
	}

	/**
	* @generated
	*/
	private IParser formName_5002Parser;

	/**
	* @generated
	*/
	private IParser getFormName_5002Parser() {
		if (formName_5002Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			formName_5002Parser = parser;
		}
		return formName_5002Parser;
	}

	/**
	* @generated
	*/
	private IParser dataName_5037Parser;

	/**
	* @generated
	*/
	private IParser getDataName_5037Parser() {
		if (dataName_5037Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			dataName_5037Parser = parser;
		}
		return dataName_5037Parser;
	}

	/**
	* @generated
	*/
	private IParser simpleFieldName_5038Parser;

	/**
	* @generated
	*/
	private IParser getSimpleFieldName_5038Parser() {
		if (simpleFieldName_5038Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			simpleFieldName_5038Parser = parser;
		}
		return simpleFieldName_5038Parser;
	}

	/**
	* @generated
	*/
	private IParser selectionFieldName_5039Parser;

	/**
	* @generated
	*/
	private IParser getSelectionFieldName_5039Parser() {
		if (selectionFieldName_5039Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			selectionFieldName_5039Parser = parser;
		}
		return selectionFieldName_5039Parser;
	}

	/**
	* @generated
	*/
	private IParser labelName_5040Parser;

	/**
	* @generated
	*/
	private IParser getLabelName_5040Parser() {
		if (labelName_5040Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			labelName_5040Parser = parser;
		}
		return labelName_5040Parser;
	}

	/**
	* @generated
	*/
	private IParser listName_5003Parser;

	/**
	* @generated
	*/
	private IParser getListName_5003Parser() {
		if (listName_5003Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			listName_5003Parser = parser;
		}
		return listName_5003Parser;
	}

	/**
	* @generated
	*/
	private IParser detailsName_5004Parser;

	/**
	* @generated
	*/
	private IParser getDetailsName_5004Parser() {
		if (detailsName_5004Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			detailsName_5004Parser = parser;
		}
		return detailsName_5004Parser;
	}

	/**
	* @generated
	*/
	private IParser textBoxName_5041Parser;

	/**
	* @generated
	*/
	private IParser getTextBoxName_5041Parser() {
		if (textBoxName_5041Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			textBoxName_5041Parser = parser;
		}
		return textBoxName_5041Parser;
	}

	/**
	* @generated
	*/
	private IParser staticContentName_5042Parser;

	/**
	* @generated
	*/
	private IParser getStaticContentName_5042Parser() {
		if (staticContentName_5042Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			staticContentName_5042Parser = parser;
		}
		return staticContentName_5042Parser;
	}

	/**
	* @generated
	*/
	private IParser messageName_5005Parser;

	/**
	* @generated
	*/
	private IParser getMessageName_5005Parser() {
		if (messageName_5005Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			messageName_5005Parser = parser;
		}
		return messageName_5005Parser;
	}

	/**
	* @generated
	*/
	private IParser utilityViewName_5006Parser;

	/**
	* @generated
	*/
	private IParser getUtilityViewName_5006Parser() {
		if (utilityViewName_5006Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			utilityViewName_5006Parser = parser;
		}
		return utilityViewName_5006Parser;
	}

	/**
	* @generated
	*/
	private IParser mapName_5043Parser;

	/**
	* @generated
	*/
	private IParser getMapName_5043Parser() {
		if (mapName_5043Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			mapName_5043Parser = parser;
		}
		return mapName_5043Parser;
	}

	/**
	* @generated
	*/
	private IParser codeName_5044Parser;

	/**
	* @generated
	*/
	private IParser getCodeName_5044Parser() {
		if (codeName_5044Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			codeName_5044Parser = parser;
		}
		return codeName_5044Parser;
	}

	/**
	* @generated
	*/
	private IParser calendarName_5045Parser;

	/**
	* @generated
	*/
	private IParser getCalendarName_5045Parser() {
		if (calendarName_5045Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			calendarName_5045Parser = parser;
		}
		return calendarName_5045Parser;
	}

	/**
	* @generated
	*/
	private IParser searchViewName_5007Parser;

	/**
	* @generated
	*/
	private IParser getSearchViewName_5007Parser() {
		if (searchViewName_5007Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			searchViewName_5007Parser = parser;
		}
		return searchViewName_5007Parser;
	}

	/**
	* @generated
	*/
	private IParser toolBarName_5008Parser;

	/**
	* @generated
	*/
	private IParser getToolBarName_5008Parser() {
		if (toolBarName_5008Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			toolBarName_5008Parser = parser;
		}
		return toolBarName_5008Parser;
	}

	/**
	* @generated
	*/
	private IParser iconName_5046Parser;

	/**
	* @generated
	*/
	private IParser getIconName_5046Parser() {
		if (iconName_5046Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			iconName_5046Parser = parser;
		}
		return iconName_5046Parser;
	}

	/**
	* @generated
	*/
	private IParser longPressEventName_5009Parser;

	/**
	* @generated
	*/
	private IParser getLongPressEventName_5009Parser() {
		if (longPressEventName_5009Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			longPressEventName_5009Parser = parser;
		}
		return longPressEventName_5009Parser;
	}

	/**
	* @generated
	*/
	private IParser otherActionEventName_5019Parser;

	/**
	* @generated
	*/
	private IParser getOtherActionEventName_5019Parser() {
		if (otherActionEventName_5019Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			otherActionEventName_5019Parser = parser;
		}
		return otherActionEventName_5019Parser;
	}

	/**
	* @generated
	*/
	private IParser cameraActionEventName_5021Parser;

	/**
	* @generated
	*/
	private IParser getCameraActionEventName_5021Parser() {
		if (cameraActionEventName_5021Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			cameraActionEventName_5021Parser = parser;
		}
		return cameraActionEventName_5021Parser;
	}

	/**
	* @generated
	*/
	private IParser microphoneActionEventName_5023Parser;

	/**
	* @generated
	*/
	private IParser getMicrophoneActionEventName_5023Parser() {
		if (microphoneActionEventName_5023Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			microphoneActionEventName_5023Parser = parser;
		}
		return microphoneActionEventName_5023Parser;
	}

	/**
	* @generated
	*/
	private IParser dataBindingSourceData_5047Parser;

	/**
	* @generated
	*/
	private IParser getDataBindingSourceData_5047Parser() {
		if (dataBindingSourceData_5047Parser == null) {
			EStructuralFeature editableFeature = MuicmPackage.eINSTANCE.getDataBinding_SourceData();
			ChoiceParserBase parser = new OclChoiceParser( // 	
					editableFeature, "Data.allInstances()", null,
					MuicmDiagramEditorPlugin.getInstance().getItemProvidersAdapterFactory());
			dataBindingSourceData_5047Parser = parser;
		}
		return dataBindingSourceData_5047Parser;
	}

	/**
	* @generated
	*/
	private IParser dataBindingTargetData_5048Parser;

	/**
	* @generated
	*/
	private IParser getDataBindingTargetData_5048Parser() {
		if (dataBindingTargetData_5048Parser == null) {
			EStructuralFeature editableFeature = MuicmPackage.eINSTANCE.getDataBinding_TargetData();
			ChoiceParserBase parser = new OclChoiceParser( // 	
					editableFeature, "Data.allInstances()", null,
					MuicmDiagramEditorPlugin.getInstance().getItemProvidersAdapterFactory());
			dataBindingTargetData_5048Parser = parser;
		}
		return dataBindingTargetData_5048Parser;
	}

	/**
	* @generated
	*/
	private IParser navigationFlowName_6001Parser;

	/**
	* @generated
	*/
	private IParser getNavigationFlowName_6001Parser() {
		if (navigationFlowName_6001Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			navigationFlowName_6001Parser = parser;
		}
		return navigationFlowName_6001Parser;
	}

	/**
	* @generated
	*/
	private IParser dataFlowName_6002Parser;

	/**
	* @generated
	*/
	private IParser getDataFlowName_6002Parser() {
		if (dataFlowName_6002Parser == null) {
			EAttribute[] features = new EAttribute[] { MuicmPackage.eINSTANCE.getMUICMElement_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			dataFlowName_6002Parser = parser;
		}
		return dataFlowName_6002Parser;
	}

	/**
	* @generated
	*/
	protected IParser getParser(int visualID) {
		switch (visualID) {
		case ScreenNameEditPart.VISUAL_ID:
			return getScreenName_5017Parser();
		case MViewComponentNameEditPart.VISUAL_ID:
			return getMViewComponentName_5018Parser();
		case OtherActionNameEditPart.VISUAL_ID:
			return getOtherActionName_5020Parser();
		case CameraActionNameEditPart.VISUAL_ID:
			return getCameraActionName_5022Parser();
		case MicrophoneActionNameEditPart.VISUAL_ID:
			return getMicrophoneActionName_5024Parser();
		case DataBindingGroupNameEditPart.VISUAL_ID:
			return getDataBindingGroupName_5025Parser();
		case ScreenName2EditPart.VISUAL_ID:
			return getScreenName_5016Parser();
		case MViewComponentName2EditPart.VISUAL_ID:
			return getMViewComponentName_5001Parser();
		case LabelNameEditPart.VISUAL_ID:
			return getLabelName_5026Parser();
		case TextBoxNameEditPart.VISUAL_ID:
			return getTextBoxName_5027Parser();
		case MapNameEditPart.VISUAL_ID:
			return getMapName_5028Parser();
		case CalendarNameEditPart.VISUAL_ID:
			return getCalendarName_5029Parser();
		case CodeNameEditPart.VISUAL_ID:
			return getCodeName_5030Parser();
		case SimpleFieldNameEditPart.VISUAL_ID:
			return getSimpleFieldName_5031Parser();
		case SelectionFieldNameEditPart.VISUAL_ID:
			return getSelectionFieldName_5032Parser();
		case SwipeEventNameEditPart.VISUAL_ID:
			return getSwipeEventName_5013Parser();
		case TapEventNameEditPart.VISUAL_ID:
			return getTapEventName_5014Parser();
		case TouchEventNameEditPart.VISUAL_ID:
			return getTouchEventName_5015Parser();
		case PanEventNameEditPart.VISUAL_ID:
			return getPanEventName_5010Parser();
		case PinchEventNameEditPart.VISUAL_ID:
			return getPinchEventName_5011Parser();
		case RotateEventNameEditPart.VISUAL_ID:
			return getRotateEventName_5012Parser();
		case MViewElementEventNameEditPart.VISUAL_ID:
			return getMViewElementEventName_5033Parser();
		case MViewComponentPartNameEditPart.VISUAL_ID:
			return getMViewComponentPartName_5034Parser();
		case StaticContentNameEditPart.VISUAL_ID:
			return getStaticContentName_5035Parser();
		case DynamicBehaviourNameEditPart.VISUAL_ID:
			return getDynamicBehaviourName_5036Parser();
		case MediaNameEditPart.VISUAL_ID:
			return getMediaName_5049Parser();
		case FormNameEditPart.VISUAL_ID:
			return getFormName_5002Parser();
		case DataNameEditPart.VISUAL_ID:
			return getDataName_5037Parser();
		case SimpleFieldName2EditPart.VISUAL_ID:
			return getSimpleFieldName_5038Parser();
		case SelectionFieldName2EditPart.VISUAL_ID:
			return getSelectionFieldName_5039Parser();
		case LabelName2EditPart.VISUAL_ID:
			return getLabelName_5040Parser();
		case ListNameEditPart.VISUAL_ID:
			return getListName_5003Parser();
		case DetailsNameEditPart.VISUAL_ID:
			return getDetailsName_5004Parser();
		case TextBoxName2EditPart.VISUAL_ID:
			return getTextBoxName_5041Parser();
		case StaticContentName2EditPart.VISUAL_ID:
			return getStaticContentName_5042Parser();
		case MessageNameEditPart.VISUAL_ID:
			return getMessageName_5005Parser();
		case UtilityViewNameEditPart.VISUAL_ID:
			return getUtilityViewName_5006Parser();
		case MapName2EditPart.VISUAL_ID:
			return getMapName_5043Parser();
		case CodeName2EditPart.VISUAL_ID:
			return getCodeName_5044Parser();
		case CalendarName2EditPart.VISUAL_ID:
			return getCalendarName_5045Parser();
		case SearchViewNameEditPart.VISUAL_ID:
			return getSearchViewName_5007Parser();
		case ToolBarNameEditPart.VISUAL_ID:
			return getToolBarName_5008Parser();
		case IconNameEditPart.VISUAL_ID:
			return getIconName_5046Parser();
		case LongPressEventNameEditPart.VISUAL_ID:
			return getLongPressEventName_5009Parser();
		case OtherActionEventNameEditPart.VISUAL_ID:
			return getOtherActionEventName_5019Parser();
		case CameraActionEventNameEditPart.VISUAL_ID:
			return getCameraActionEventName_5021Parser();
		case MicrophoneActionEventNameEditPart.VISUAL_ID:
			return getMicrophoneActionEventName_5023Parser();

		case DataBindingSourceDataEditPart.VISUAL_ID:
			return getDataBindingSourceData_5047Parser();

		case DataBindingTargetDataEditPart.VISUAL_ID:
			return getDataBindingTargetData_5048Parser();
		case NavigationFlowNameEditPart.VISUAL_ID:
			return getNavigationFlowName_6001Parser();
		case DataFlowNameEditPart.VISUAL_ID:
			return getDataFlowName_6002Parser();
		}
		return null;
	}

	/**
	* Utility method that consults ParserService
	* @generated
	*/
	public static IParser getParser(IElementType type, EObject object, String parserHint) {
		return ParserService.getInstance().getParser(new HintAdapter(type, object, parserHint));
	}

	/**
	* @generated
	*/
	public IParser getParser(IAdaptable hint) {
		String vid = (String) hint.getAdapter(String.class);
		if (vid != null) {
			return getParser(MuicmVisualIDRegistry.getVisualID(vid));
		}
		View view = (View) hint.getAdapter(View.class);
		if (view != null) {
			return getParser(MuicmVisualIDRegistry.getVisualID(view));
		}
		return null;
	}

	/**
	* @generated
	*/
	public boolean provides(IOperation operation) {
		if (operation instanceof GetParserOperation) {
			IAdaptable hint = ((GetParserOperation) operation).getHint();
			if (MuicmElementTypes.getElement(hint) == null) {
				return false;
			}
			return getParser(hint) != null;
		}
		return false;
	}

	/**
	* @generated
	*/
	private static class HintAdapter extends ParserHintAdapter {

		/**
		* @generated
		*/
		private final IElementType elementType;

		/**
		* @generated
		*/
		public HintAdapter(IElementType type, EObject object, String parserHint) {
			super(object, parserHint);
			assert type != null;
			elementType = type;
		}

		/**
		* @generated
		*/
		public Object getAdapter(Class adapter) {
			if (IElementType.class.equals(adapter)) {
				return elementType;
			}
			return super.getAdapter(adapter);
		}
	}

}
