package muicm.diagram.providers.assistants;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;

import muicm.diagram.edit.parts.Calendar2EditPart;
import muicm.diagram.edit.parts.CalendarEditPart;
import muicm.diagram.edit.parts.CameraActionEditPart;
import muicm.diagram.edit.parts.CameraActionEventEditPart;
import muicm.diagram.edit.parts.Code2EditPart;
import muicm.diagram.edit.parts.CodeEditPart;
import muicm.diagram.edit.parts.DetailsEditPart;
import muicm.diagram.edit.parts.DynamicBehaviourEditPart;
import muicm.diagram.edit.parts.FormEditPart;
import muicm.diagram.edit.parts.IconEditPart;
import muicm.diagram.edit.parts.Label2EditPart;
import muicm.diagram.edit.parts.LabelEditPart;
import muicm.diagram.edit.parts.ListEditPart;
import muicm.diagram.edit.parts.LongPressEventEditPart;
import muicm.diagram.edit.parts.MViewComponent2EditPart;
import muicm.diagram.edit.parts.MViewComponentEditPart;
import muicm.diagram.edit.parts.MViewComponentPartEditPart;
import muicm.diagram.edit.parts.MViewElementEventEditPart;
import muicm.diagram.edit.parts.Map2EditPart;
import muicm.diagram.edit.parts.MapEditPart;
import muicm.diagram.edit.parts.MediaEditPart;
import muicm.diagram.edit.parts.MessageEditPart;
import muicm.diagram.edit.parts.MicrophoneActionEditPart;
import muicm.diagram.edit.parts.MicrophoneActionEventEditPart;
import muicm.diagram.edit.parts.OtherActionEditPart;
import muicm.diagram.edit.parts.OtherActionEventEditPart;
import muicm.diagram.edit.parts.PanEventEditPart;
import muicm.diagram.edit.parts.PinchEventEditPart;
import muicm.diagram.edit.parts.RotateEventEditPart;
import muicm.diagram.edit.parts.Screen2EditPart;
import muicm.diagram.edit.parts.ScreenEditPart;
import muicm.diagram.edit.parts.SearchViewEditPart;
import muicm.diagram.edit.parts.SelectionField2EditPart;
import muicm.diagram.edit.parts.SelectionFieldEditPart;
import muicm.diagram.edit.parts.SimpleField2EditPart;
import muicm.diagram.edit.parts.SimpleFieldEditPart;
import muicm.diagram.edit.parts.StaticContent2EditPart;
import muicm.diagram.edit.parts.StaticContentEditPart;
import muicm.diagram.edit.parts.SwipeEventEditPart;
import muicm.diagram.edit.parts.TapEventEditPart;
import muicm.diagram.edit.parts.TextBox2EditPart;
import muicm.diagram.edit.parts.TextBoxEditPart;
import muicm.diagram.edit.parts.ToolBarEditPart;
import muicm.diagram.edit.parts.TouchEventEditPart;
import muicm.diagram.edit.parts.UtilityViewEditPart;
import muicm.diagram.providers.MuicmElementTypes;
import muicm.diagram.providers.MuicmModelingAssistantProvider;

/**
 * @generated
 */
public class MuicmModelingAssistantProviderOfCalendarEditPart extends MuicmModelingAssistantProvider {

	/**
	* @generated
	*/
	@Override

	public List<IElementType> getRelTypesOnSource(IAdaptable source) {
		IGraphicalEditPart sourceEditPart = (IGraphicalEditPart) source.getAdapter(IGraphicalEditPart.class);
		return doGetRelTypesOnSource((CalendarEditPart) sourceEditPart);
	}

	/**
	* @generated
	*/
	public List<IElementType> doGetRelTypesOnSource(CalendarEditPart source) {
		List<IElementType> types = new ArrayList<IElementType>(2);
		types.add(MuicmElementTypes.NavigationFlow_4002);
		types.add(MuicmElementTypes.DataFlow_4003);
		return types;
	}

	/**
	* @generated
	*/
	@Override

	public List<IElementType> getRelTypesOnSourceAndTarget(IAdaptable source, IAdaptable target) {
		IGraphicalEditPart sourceEditPart = (IGraphicalEditPart) source.getAdapter(IGraphicalEditPart.class);
		IGraphicalEditPart targetEditPart = (IGraphicalEditPart) target.getAdapter(IGraphicalEditPart.class);
		return doGetRelTypesOnSourceAndTarget((CalendarEditPart) sourceEditPart, targetEditPart);
	}

	/**
	* @generated
	*/
	public List<IElementType> doGetRelTypesOnSourceAndTarget(CalendarEditPart source,
			IGraphicalEditPart targetEditPart) {
		List<IElementType> types = new LinkedList<IElementType>();
		if (targetEditPart instanceof ScreenEditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof MViewComponentEditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof OtherActionEditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof CameraActionEditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof MicrophoneActionEditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof Screen2EditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof MViewComponent2EditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof LabelEditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof TextBoxEditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof MapEditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof CalendarEditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof CodeEditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof SimpleFieldEditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof SelectionFieldEditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof SwipeEventEditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof TapEventEditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof TouchEventEditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof PanEventEditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof PinchEventEditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof RotateEventEditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof MViewElementEventEditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof MViewComponentPartEditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof StaticContentEditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof DynamicBehaviourEditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof MediaEditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof FormEditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof SimpleField2EditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof SelectionField2EditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof Label2EditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof ListEditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof DetailsEditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof TextBox2EditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof StaticContent2EditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof MessageEditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof UtilityViewEditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof Map2EditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof Code2EditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof Calendar2EditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof SearchViewEditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof ToolBarEditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof IconEditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof LongPressEventEditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof OtherActionEventEditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof CameraActionEventEditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof MicrophoneActionEventEditPart) {
			types.add(MuicmElementTypes.NavigationFlow_4002);
		}
		if (targetEditPart instanceof ScreenEditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof MViewComponentEditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof OtherActionEditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof CameraActionEditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof MicrophoneActionEditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof Screen2EditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof MViewComponent2EditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof LabelEditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof TextBoxEditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof MapEditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof CalendarEditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof CodeEditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof SimpleFieldEditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof SelectionFieldEditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof SwipeEventEditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof TapEventEditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof TouchEventEditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof PanEventEditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof PinchEventEditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof RotateEventEditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof MViewElementEventEditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof MViewComponentPartEditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof StaticContentEditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof DynamicBehaviourEditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof MediaEditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof FormEditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof SimpleField2EditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof SelectionField2EditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof Label2EditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof ListEditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof DetailsEditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof TextBox2EditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof StaticContent2EditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof MessageEditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof UtilityViewEditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof Map2EditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof Code2EditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof Calendar2EditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof SearchViewEditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof ToolBarEditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof IconEditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof LongPressEventEditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof OtherActionEventEditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof CameraActionEventEditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		if (targetEditPart instanceof MicrophoneActionEventEditPart) {
			types.add(MuicmElementTypes.DataFlow_4003);
		}
		return types;
	}

	/**
	* @generated
	*/
	@Override

	public List<IElementType> getTypesForTarget(IAdaptable source, IElementType relationshipType) {
		IGraphicalEditPart sourceEditPart = (IGraphicalEditPart) source.getAdapter(IGraphicalEditPart.class);
		return doGetTypesForTarget((CalendarEditPart) sourceEditPart, relationshipType);
	}

	/**
	* @generated
	*/
	public List<IElementType> doGetTypesForTarget(CalendarEditPart source, IElementType relationshipType) {
		List<IElementType> types = new ArrayList<IElementType>();
		if (relationshipType == MuicmElementTypes.NavigationFlow_4002) {
			types.add(MuicmElementTypes.Screen_2001);
			types.add(MuicmElementTypes.MViewComponent_2002);
			types.add(MuicmElementTypes.OtherAction_2003);
			types.add(MuicmElementTypes.CameraAction_2004);
			types.add(MuicmElementTypes.MicrophoneAction_2005);
			types.add(MuicmElementTypes.Screen_3001);
			types.add(MuicmElementTypes.MViewComponent_3002);
			types.add(MuicmElementTypes.Label_3021);
			types.add(MuicmElementTypes.TextBox_3022);
			types.add(MuicmElementTypes.Map_3023);
			types.add(MuicmElementTypes.Calendar_3024);
			types.add(MuicmElementTypes.Code_3025);
			types.add(MuicmElementTypes.SimpleField_3026);
			types.add(MuicmElementTypes.SelectionField_3027);
			types.add(MuicmElementTypes.SwipeEvent_3014);
			types.add(MuicmElementTypes.TapEvent_3015);
			types.add(MuicmElementTypes.TouchEvent_3016);
			types.add(MuicmElementTypes.PanEvent_3011);
			types.add(MuicmElementTypes.PinchEvent_3012);
			types.add(MuicmElementTypes.RotateEvent_3013);
			types.add(MuicmElementTypes.MViewElementEvent_3028);
			types.add(MuicmElementTypes.MViewComponentPart_3029);
			types.add(MuicmElementTypes.StaticContent_3030);
			types.add(MuicmElementTypes.DynamicBehaviour_3031);
			types.add(MuicmElementTypes.Media_3042);
			types.add(MuicmElementTypes.Form_3003);
			types.add(MuicmElementTypes.SimpleField_3033);
			types.add(MuicmElementTypes.SelectionField_3034);
			types.add(MuicmElementTypes.Label_3035);
			types.add(MuicmElementTypes.List_3004);
			types.add(MuicmElementTypes.Details_3005);
			types.add(MuicmElementTypes.TextBox_3036);
			types.add(MuicmElementTypes.StaticContent_3037);
			types.add(MuicmElementTypes.Message_3006);
			types.add(MuicmElementTypes.UtilityView_3007);
			types.add(MuicmElementTypes.Map_3038);
			types.add(MuicmElementTypes.Code_3039);
			types.add(MuicmElementTypes.Calendar_3040);
			types.add(MuicmElementTypes.SearchView_3008);
			types.add(MuicmElementTypes.ToolBar_3009);
			types.add(MuicmElementTypes.Icon_3041);
			types.add(MuicmElementTypes.LongPressEvent_3010);
			types.add(MuicmElementTypes.OtherActionEvent_3017);
			types.add(MuicmElementTypes.CameraActionEvent_3018);
			types.add(MuicmElementTypes.MicrophoneActionEvent_3019);
		} else if (relationshipType == MuicmElementTypes.DataFlow_4003) {
			types.add(MuicmElementTypes.Screen_2001);
			types.add(MuicmElementTypes.MViewComponent_2002);
			types.add(MuicmElementTypes.OtherAction_2003);
			types.add(MuicmElementTypes.CameraAction_2004);
			types.add(MuicmElementTypes.MicrophoneAction_2005);
			types.add(MuicmElementTypes.Screen_3001);
			types.add(MuicmElementTypes.MViewComponent_3002);
			types.add(MuicmElementTypes.Label_3021);
			types.add(MuicmElementTypes.TextBox_3022);
			types.add(MuicmElementTypes.Map_3023);
			types.add(MuicmElementTypes.Calendar_3024);
			types.add(MuicmElementTypes.Code_3025);
			types.add(MuicmElementTypes.SimpleField_3026);
			types.add(MuicmElementTypes.SelectionField_3027);
			types.add(MuicmElementTypes.SwipeEvent_3014);
			types.add(MuicmElementTypes.TapEvent_3015);
			types.add(MuicmElementTypes.TouchEvent_3016);
			types.add(MuicmElementTypes.PanEvent_3011);
			types.add(MuicmElementTypes.PinchEvent_3012);
			types.add(MuicmElementTypes.RotateEvent_3013);
			types.add(MuicmElementTypes.MViewElementEvent_3028);
			types.add(MuicmElementTypes.MViewComponentPart_3029);
			types.add(MuicmElementTypes.StaticContent_3030);
			types.add(MuicmElementTypes.DynamicBehaviour_3031);
			types.add(MuicmElementTypes.Media_3042);
			types.add(MuicmElementTypes.Form_3003);
			types.add(MuicmElementTypes.SimpleField_3033);
			types.add(MuicmElementTypes.SelectionField_3034);
			types.add(MuicmElementTypes.Label_3035);
			types.add(MuicmElementTypes.List_3004);
			types.add(MuicmElementTypes.Details_3005);
			types.add(MuicmElementTypes.TextBox_3036);
			types.add(MuicmElementTypes.StaticContent_3037);
			types.add(MuicmElementTypes.Message_3006);
			types.add(MuicmElementTypes.UtilityView_3007);
			types.add(MuicmElementTypes.Map_3038);
			types.add(MuicmElementTypes.Code_3039);
			types.add(MuicmElementTypes.Calendar_3040);
			types.add(MuicmElementTypes.SearchView_3008);
			types.add(MuicmElementTypes.ToolBar_3009);
			types.add(MuicmElementTypes.Icon_3041);
			types.add(MuicmElementTypes.LongPressEvent_3010);
			types.add(MuicmElementTypes.OtherActionEvent_3017);
			types.add(MuicmElementTypes.CameraActionEvent_3018);
			types.add(MuicmElementTypes.MicrophoneActionEvent_3019);
		}
		return types;
	}

	/**
	* @generated
	*/
	@Override

	public List<IElementType> getRelTypesOnTarget(IAdaptable target) {
		IGraphicalEditPart targetEditPart = (IGraphicalEditPart) target.getAdapter(IGraphicalEditPart.class);
		return doGetRelTypesOnTarget((CalendarEditPart) targetEditPart);
	}

	/**
	* @generated
	*/
	public List<IElementType> doGetRelTypesOnTarget(CalendarEditPart target) {
		List<IElementType> types = new ArrayList<IElementType>(2);
		types.add(MuicmElementTypes.NavigationFlow_4002);
		types.add(MuicmElementTypes.DataFlow_4003);
		return types;
	}

	/**
	* @generated
	*/
	@Override

	public List<IElementType> getTypesForSource(IAdaptable target, IElementType relationshipType) {
		IGraphicalEditPart targetEditPart = (IGraphicalEditPart) target.getAdapter(IGraphicalEditPart.class);
		return doGetTypesForSource((CalendarEditPart) targetEditPart, relationshipType);
	}

	/**
	* @generated
	*/
	public List<IElementType> doGetTypesForSource(CalendarEditPart target, IElementType relationshipType) {
		List<IElementType> types = new ArrayList<IElementType>();
		if (relationshipType == MuicmElementTypes.NavigationFlow_4002) {
			types.add(MuicmElementTypes.Screen_2001);
			types.add(MuicmElementTypes.MViewComponent_2002);
			types.add(MuicmElementTypes.OtherAction_2003);
			types.add(MuicmElementTypes.CameraAction_2004);
			types.add(MuicmElementTypes.MicrophoneAction_2005);
			types.add(MuicmElementTypes.Screen_3001);
			types.add(MuicmElementTypes.MViewComponent_3002);
			types.add(MuicmElementTypes.Label_3021);
			types.add(MuicmElementTypes.TextBox_3022);
			types.add(MuicmElementTypes.Map_3023);
			types.add(MuicmElementTypes.Calendar_3024);
			types.add(MuicmElementTypes.Code_3025);
			types.add(MuicmElementTypes.SimpleField_3026);
			types.add(MuicmElementTypes.SelectionField_3027);
			types.add(MuicmElementTypes.SwipeEvent_3014);
			types.add(MuicmElementTypes.TapEvent_3015);
			types.add(MuicmElementTypes.TouchEvent_3016);
			types.add(MuicmElementTypes.PanEvent_3011);
			types.add(MuicmElementTypes.PinchEvent_3012);
			types.add(MuicmElementTypes.RotateEvent_3013);
			types.add(MuicmElementTypes.MViewElementEvent_3028);
			types.add(MuicmElementTypes.MViewComponentPart_3029);
			types.add(MuicmElementTypes.StaticContent_3030);
			types.add(MuicmElementTypes.DynamicBehaviour_3031);
			types.add(MuicmElementTypes.Media_3042);
			types.add(MuicmElementTypes.Form_3003);
			types.add(MuicmElementTypes.SimpleField_3033);
			types.add(MuicmElementTypes.SelectionField_3034);
			types.add(MuicmElementTypes.Label_3035);
			types.add(MuicmElementTypes.List_3004);
			types.add(MuicmElementTypes.Details_3005);
			types.add(MuicmElementTypes.TextBox_3036);
			types.add(MuicmElementTypes.StaticContent_3037);
			types.add(MuicmElementTypes.Message_3006);
			types.add(MuicmElementTypes.UtilityView_3007);
			types.add(MuicmElementTypes.Map_3038);
			types.add(MuicmElementTypes.Code_3039);
			types.add(MuicmElementTypes.Calendar_3040);
			types.add(MuicmElementTypes.SearchView_3008);
			types.add(MuicmElementTypes.ToolBar_3009);
			types.add(MuicmElementTypes.Icon_3041);
			types.add(MuicmElementTypes.LongPressEvent_3010);
			types.add(MuicmElementTypes.OtherActionEvent_3017);
			types.add(MuicmElementTypes.CameraActionEvent_3018);
			types.add(MuicmElementTypes.MicrophoneActionEvent_3019);
		} else if (relationshipType == MuicmElementTypes.DataFlow_4003) {
			types.add(MuicmElementTypes.Screen_2001);
			types.add(MuicmElementTypes.MViewComponent_2002);
			types.add(MuicmElementTypes.OtherAction_2003);
			types.add(MuicmElementTypes.CameraAction_2004);
			types.add(MuicmElementTypes.MicrophoneAction_2005);
			types.add(MuicmElementTypes.Screen_3001);
			types.add(MuicmElementTypes.MViewComponent_3002);
			types.add(MuicmElementTypes.Label_3021);
			types.add(MuicmElementTypes.TextBox_3022);
			types.add(MuicmElementTypes.Map_3023);
			types.add(MuicmElementTypes.Calendar_3024);
			types.add(MuicmElementTypes.Code_3025);
			types.add(MuicmElementTypes.SimpleField_3026);
			types.add(MuicmElementTypes.SelectionField_3027);
			types.add(MuicmElementTypes.SwipeEvent_3014);
			types.add(MuicmElementTypes.TapEvent_3015);
			types.add(MuicmElementTypes.TouchEvent_3016);
			types.add(MuicmElementTypes.PanEvent_3011);
			types.add(MuicmElementTypes.PinchEvent_3012);
			types.add(MuicmElementTypes.RotateEvent_3013);
			types.add(MuicmElementTypes.MViewElementEvent_3028);
			types.add(MuicmElementTypes.MViewComponentPart_3029);
			types.add(MuicmElementTypes.StaticContent_3030);
			types.add(MuicmElementTypes.DynamicBehaviour_3031);
			types.add(MuicmElementTypes.Media_3042);
			types.add(MuicmElementTypes.Form_3003);
			types.add(MuicmElementTypes.SimpleField_3033);
			types.add(MuicmElementTypes.SelectionField_3034);
			types.add(MuicmElementTypes.Label_3035);
			types.add(MuicmElementTypes.List_3004);
			types.add(MuicmElementTypes.Details_3005);
			types.add(MuicmElementTypes.TextBox_3036);
			types.add(MuicmElementTypes.StaticContent_3037);
			types.add(MuicmElementTypes.Message_3006);
			types.add(MuicmElementTypes.UtilityView_3007);
			types.add(MuicmElementTypes.Map_3038);
			types.add(MuicmElementTypes.Code_3039);
			types.add(MuicmElementTypes.Calendar_3040);
			types.add(MuicmElementTypes.SearchView_3008);
			types.add(MuicmElementTypes.ToolBar_3009);
			types.add(MuicmElementTypes.Icon_3041);
			types.add(MuicmElementTypes.LongPressEvent_3010);
			types.add(MuicmElementTypes.OtherActionEvent_3017);
			types.add(MuicmElementTypes.CameraActionEvent_3018);
			types.add(MuicmElementTypes.MicrophoneActionEvent_3019);
		}
		return types;
	}

}
