/**
 */
package muicm.impl;

import muicm.Attribute;
import muicm.BehaviourConcept;
import muicm.Calendar;
import muicm.CameraAction;
import muicm.CameraActionEvent;
import muicm.Code;
import muicm.CodeType;
import muicm.ConditionalExpression;
import muicm.ContentBinding;
import muicm.ContentElement;
import muicm.ContentModel;
import muicm.Data;
import muicm.DataBinding;
import muicm.DataBindingGroup;
import muicm.DataFlow;
import muicm.DataType;
import muicm.Details;
import muicm.DirType;
import muicm.DomainConcept;
import muicm.DynamicBehaviour;
import muicm.EventType;
import muicm.FeatureConcept;
import muicm.Field;
import muicm.Form;
import muicm.Icon;
import muicm.Label;
import muicm.List;
import muicm.LongPressEvent;
import muicm.MAction;
import muicm.MActionEvent;
import muicm.MEvent;
import muicm.MExpression;
import muicm.MInteractionElement;
import muicm.MInteractionFlow;
import muicm.MUICMElement;
import muicm.MViewComponent;
import muicm.MViewComponentPart;
import muicm.MViewComponentPartAbstract;
import muicm.MViewElement;
import muicm.MViewElementEvent;
import muicm.MViewElementEventAbstract;
import muicm.Map;
import muicm.Media;
import muicm.MeidaType;
import muicm.Message;
import muicm.MicrophoneAction;
import muicm.MicrophoneActionEvent;
import muicm.MuicmFactory;
import muicm.MuicmPackage;
import muicm.MviewComponentExt;
import muicm.NavigationFlow;
import muicm.OtherAction;
import muicm.OtherActionEvent;
import muicm.PanEvent;
import muicm.PinchEvent;
import muicm.RotateEvent;
import muicm.Screen;
import muicm.SearchView;
import muicm.SelectionField;
import muicm.SimpleField;
import muicm.StaticContent;
import muicm.SwipeDirection;
import muicm.SwipeEvent;
import muicm.SystemEvent;
import muicm.TapEvent;
import muicm.TextBox;
import muicm.ToolBar;
import muicm.TouchEvent;
import muicm.Utility;
import muicm.UtilityView;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import org.eclipse.emf.ecore.impl.EPackageImpl;

import org.eclipse.emf.ecore.xml.type.XMLTypePackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class MuicmPackageImpl extends EPackageImpl implements MuicmPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass muicmEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass muicmElementEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mInteractionFlowEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass navigationFlowEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass dataFlowEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mInteractionElementEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass dataBindingGroupEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass dataBindingEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass dataEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mViewElementEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass screenEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mviewComponentExtEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mViewComponentEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass searchViewEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass listEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass toolBarEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass formEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass messageEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass detailsEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass utilityViewEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mViewComponentPartAbstractEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass fieldEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass simpleFieldEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass selectionFieldEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass textBoxEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mediaEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass labelEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass utilityEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mapEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass calendarEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass codeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass iconEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass contentBindingEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mEventEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mViewElementEventAbstractEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mViewComponentPartEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mViewElementEventEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass pinchEventEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass rotateEventEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass tapEventEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass systemEventEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass panEventEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass touchEventEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass longPressEventEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass swipeEventEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mActionEventEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass cameraActionEventEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass microphoneActionEventEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass otherActionEventEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mExpressionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass cameraActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass microphoneActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass otherActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass conditionalExpressionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass staticContentEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass dynamicBehaviourEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass contentModelEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass contentElementEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass behaviourConceptEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass domainConceptEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass featureConceptEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass attributeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum dataTypeEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum meidaTypeEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum swipeDirectionEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum codeTypeEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum eventTypeEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum dirTypeEEnum = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see muicm.MuicmPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private MuicmPackageImpl() {
		super(eNS_URI, MuicmFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link MuicmPackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static MuicmPackage init() {
		if (isInited) return (MuicmPackage)EPackage.Registry.INSTANCE.getEPackage(MuicmPackage.eNS_URI);

		// Obtain or create and register package
		MuicmPackageImpl theMuicmPackage = (MuicmPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof MuicmPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new MuicmPackageImpl());

		isInited = true;

		// Initialize simple dependencies
		XMLTypePackage.eINSTANCE.eClass();

		// Create package meta-data objects
		theMuicmPackage.createPackageContents();

		// Initialize created meta-data
		theMuicmPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theMuicmPackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(MuicmPackage.eNS_URI, theMuicmPackage);
		return theMuicmPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMUICM() {
		return muicmEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMUICM_MuicmElements() {
		return (EReference)muicmEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMUICM_Contentmodel() {
		return (EReference)muicmEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMUICMElement() {
		return muicmElementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getMUICMElement_Name() {
		return (EAttribute)muicmElementEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMInteractionFlow() {
		return mInteractionFlowEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMInteractionFlow_SourceInteractionElement() {
		return (EReference)mInteractionFlowEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMInteractionFlow_TargetInteractionElement() {
		return (EReference)mInteractionFlowEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMInteractionFlow_DataBindingGroup() {
		return (EReference)mInteractionFlowEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getMInteractionFlow_SourceElementName() {
		return (EAttribute)mInteractionFlowEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getMInteractionFlow_TargetElementName() {
		return (EAttribute)mInteractionFlowEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getNavigationFlow() {
		return navigationFlowEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDataFlow() {
		return dataFlowEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMInteractionElement() {
		return mInteractionElementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMInteractionElement_Datas() {
		return (EReference)mInteractionElementEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDataBindingGroup() {
		return dataBindingGroupEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDataBindingGroup_DataBindings() {
		return (EReference)dataBindingGroupEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDataBinding() {
		return dataBindingEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDataBinding_SourceData() {
		return (EReference)dataBindingEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDataBinding_TargetData() {
		return (EReference)dataBindingEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDataBinding_SourceDataName() {
		return (EAttribute)dataBindingEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDataBinding_TargetDataName() {
		return (EAttribute)dataBindingEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getData() {
		return dataEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getData_Type() {
		return (EAttribute)dataEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getData_DirType() {
		return (EAttribute)dataEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getData_Visual() {
		return (EAttribute)dataEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMViewElement() {
		return mViewElementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMViewElement_MviewElementEvents() {
		return (EReference)mViewElementEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getScreen() {
		return screenEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getScreen_IsModal() {
		return (EAttribute)screenEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getScreen_HasNav() {
		return (EAttribute)screenEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getScreen_IsHome() {
		return (EAttribute)screenEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getScreen_MviewElements() {
		return (EReference)screenEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMviewComponentExt() {
		return mviewComponentExtEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMviewComponentExt_MviewComponentParts() {
		return (EReference)mviewComponentExtEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMViewComponent() {
		return mViewComponentEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMViewComponent_MviewComponentParts() {
		return (EReference)mViewComponentEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSearchView() {
		return searchViewEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getList() {
		return listEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getToolBar() {
		return toolBarEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getForm() {
		return formEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMessage() {
		return messageEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getMessage_Text() {
		return (EAttribute)messageEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDetails() {
		return detailsEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getUtilityView() {
		return utilityViewEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMViewComponentPartAbstract() {
		return mViewComponentPartAbstractEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMViewComponentPartAbstract_SubMViewComponentPart() {
		return (EReference)mViewComponentPartAbstractEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getField() {
		return fieldEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getField_Content() {
		return (EAttribute)fieldEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSimpleField() {
		return simpleFieldEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSelectionField() {
		return selectionFieldEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getSelectionField_IsMultiSelection() {
		return (EAttribute)selectionFieldEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTextBox() {
		return textBoxEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTextBox_Text() {
		return (EAttribute)textBoxEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMedia() {
		return mediaEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getMedia_Type() {
		return (EAttribute)mediaEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getMedia_MediaImage() {
		return (EAttribute)mediaEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getLabel() {
		return labelEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getLabel_Description() {
		return (EAttribute)labelEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMAction() {
		return mActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMAction_DynamicBehaviour() {
		return (EReference)mActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMAction_MactionEvents() {
		return (EReference)mActionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getUtility() {
		return utilityEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMap() {
		return mapEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getMap_Provider() {
		return (EAttribute)mapEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCalendar() {
		return calendarEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCalendar_YearsBlockSize() {
		return (EAttribute)calendarEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCode() {
		return codeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCode_Format() {
		return (EAttribute)codeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getIcon() {
		return iconEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getContentBinding() {
		return contentBindingEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMEvent() {
		return mEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMViewElementEventAbstract() {
		return mViewElementEventAbstractEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getMViewElementEventAbstract_Type() {
		return (EAttribute)mViewElementEventAbstractEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMViewComponentPart() {
		return mViewComponentPartEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMViewComponentPart_Mviewelementevent() {
		return (EReference)mViewComponentPartEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMViewElementEvent() {
		return mViewElementEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPinchEvent() {
		return pinchEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRotateEvent() {
		return rotateEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTapEvent() {
		return tapEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSystemEvent() {
		return systemEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPanEvent() {
		return panEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTouchEvent() {
		return touchEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getLongPressEvent() {
		return longPressEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getLongPressEvent_FingerCount() {
		return (EAttribute)longPressEventEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getLongPressEvent_PressDuration() {
		return (EAttribute)longPressEventEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSwipeEvent() {
		return swipeEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getSwipeEvent_Direction() {
		return (EAttribute)swipeEventEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMActionEvent() {
		return mActionEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getMActionEvent_ExecuteResult() {
		return (EAttribute)mActionEventEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCameraActionEvent() {
		return cameraActionEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMicrophoneActionEvent() {
		return microphoneActionEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getOtherActionEvent() {
		return otherActionEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMExpression() {
		return mExpressionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCameraAction() {
		return cameraActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMicrophoneAction() {
		return microphoneActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getOtherAction() {
		return otherActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getConditionalExpression() {
		return conditionalExpressionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getConditionalExpression_Expression() {
		return (EAttribute)conditionalExpressionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getStaticContent() {
		return staticContentEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getStaticContent_ConditionalExpressions() {
		return (EReference)staticContentEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getStaticContent_DomainConcept() {
		return (EReference)staticContentEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getStaticContent_Attributes() {
		return (EReference)staticContentEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDynamicBehaviour() {
		return dynamicBehaviourEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDynamicBehaviour_BehaviourConcept() {
		return (EReference)dynamicBehaviourEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getContentModel() {
		return contentModelEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getContentModel_ContentElements() {
		return (EReference)contentModelEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getContentElement() {
		return contentElementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBehaviourConcept() {
		return behaviourConceptEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDomainConcept() {
		return domainConceptEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getFeatureConcept() {
		return featureConceptEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAttribute() {
		return attributeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAttribute_FeatureConcept() {
		return (EReference)attributeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getDataType() {
		return dataTypeEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getMeidaType() {
		return meidaTypeEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getSwipeDirection() {
		return swipeDirectionEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getCodeType() {
		return codeTypeEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getEventType() {
		return eventTypeEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getDirType() {
		return dirTypeEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MuicmFactory getMuicmFactory() {
		return (MuicmFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		muicmEClass = createEClass(MUICM);
		createEReference(muicmEClass, MUICM__MUICM_ELEMENTS);
		createEReference(muicmEClass, MUICM__CONTENTMODEL);

		muicmElementEClass = createEClass(MUICM_ELEMENT);
		createEAttribute(muicmElementEClass, MUICM_ELEMENT__NAME);

		mInteractionFlowEClass = createEClass(MINTERACTION_FLOW);
		createEReference(mInteractionFlowEClass, MINTERACTION_FLOW__SOURCE_INTERACTION_ELEMENT);
		createEReference(mInteractionFlowEClass, MINTERACTION_FLOW__TARGET_INTERACTION_ELEMENT);
		createEReference(mInteractionFlowEClass, MINTERACTION_FLOW__DATA_BINDING_GROUP);
		createEAttribute(mInteractionFlowEClass, MINTERACTION_FLOW__SOURCE_ELEMENT_NAME);
		createEAttribute(mInteractionFlowEClass, MINTERACTION_FLOW__TARGET_ELEMENT_NAME);

		navigationFlowEClass = createEClass(NAVIGATION_FLOW);

		dataFlowEClass = createEClass(DATA_FLOW);

		mInteractionElementEClass = createEClass(MINTERACTION_ELEMENT);
		createEReference(mInteractionElementEClass, MINTERACTION_ELEMENT__DATAS);

		dataBindingGroupEClass = createEClass(DATA_BINDING_GROUP);
		createEReference(dataBindingGroupEClass, DATA_BINDING_GROUP__DATA_BINDINGS);

		dataBindingEClass = createEClass(DATA_BINDING);
		createEReference(dataBindingEClass, DATA_BINDING__SOURCE_DATA);
		createEReference(dataBindingEClass, DATA_BINDING__TARGET_DATA);
		createEAttribute(dataBindingEClass, DATA_BINDING__SOURCE_DATA_NAME);
		createEAttribute(dataBindingEClass, DATA_BINDING__TARGET_DATA_NAME);

		dataEClass = createEClass(DATA);
		createEAttribute(dataEClass, DATA__TYPE);
		createEAttribute(dataEClass, DATA__DIR_TYPE);
		createEAttribute(dataEClass, DATA__VISUAL);

		mViewElementEClass = createEClass(MVIEW_ELEMENT);
		createEReference(mViewElementEClass, MVIEW_ELEMENT__MVIEW_ELEMENT_EVENTS);

		screenEClass = createEClass(SCREEN);
		createEAttribute(screenEClass, SCREEN__IS_MODAL);
		createEAttribute(screenEClass, SCREEN__HAS_NAV);
		createEAttribute(screenEClass, SCREEN__IS_HOME);
		createEReference(screenEClass, SCREEN__MVIEW_ELEMENTS);

		mviewComponentExtEClass = createEClass(MVIEW_COMPONENT_EXT);
		createEReference(mviewComponentExtEClass, MVIEW_COMPONENT_EXT__MVIEW_COMPONENT_PARTS);

		mViewComponentEClass = createEClass(MVIEW_COMPONENT);
		createEReference(mViewComponentEClass, MVIEW_COMPONENT__MVIEW_COMPONENT_PARTS);

		searchViewEClass = createEClass(SEARCH_VIEW);

		listEClass = createEClass(LIST);

		toolBarEClass = createEClass(TOOL_BAR);

		formEClass = createEClass(FORM);

		messageEClass = createEClass(MESSAGE);
		createEAttribute(messageEClass, MESSAGE__TEXT);

		detailsEClass = createEClass(DETAILS);

		utilityViewEClass = createEClass(UTILITY_VIEW);

		mViewComponentPartAbstractEClass = createEClass(MVIEW_COMPONENT_PART_ABSTRACT);
		createEReference(mViewComponentPartAbstractEClass, MVIEW_COMPONENT_PART_ABSTRACT__SUB_MVIEW_COMPONENT_PART);

		fieldEClass = createEClass(FIELD);
		createEAttribute(fieldEClass, FIELD__CONTENT);

		simpleFieldEClass = createEClass(SIMPLE_FIELD);

		selectionFieldEClass = createEClass(SELECTION_FIELD);
		createEAttribute(selectionFieldEClass, SELECTION_FIELD__IS_MULTI_SELECTION);

		textBoxEClass = createEClass(TEXT_BOX);
		createEAttribute(textBoxEClass, TEXT_BOX__TEXT);

		mediaEClass = createEClass(MEDIA);
		createEAttribute(mediaEClass, MEDIA__TYPE);
		createEAttribute(mediaEClass, MEDIA__MEDIA_IMAGE);

		labelEClass = createEClass(LABEL);
		createEAttribute(labelEClass, LABEL__DESCRIPTION);

		mActionEClass = createEClass(MACTION);
		createEReference(mActionEClass, MACTION__DYNAMIC_BEHAVIOUR);
		createEReference(mActionEClass, MACTION__MACTION_EVENTS);

		utilityEClass = createEClass(UTILITY);

		mapEClass = createEClass(MAP);
		createEAttribute(mapEClass, MAP__PROVIDER);

		calendarEClass = createEClass(CALENDAR);
		createEAttribute(calendarEClass, CALENDAR__YEARS_BLOCK_SIZE);

		codeEClass = createEClass(CODE);
		createEAttribute(codeEClass, CODE__FORMAT);

		iconEClass = createEClass(ICON);

		contentBindingEClass = createEClass(CONTENT_BINDING);

		mEventEClass = createEClass(MEVENT);

		mViewElementEventAbstractEClass = createEClass(MVIEW_ELEMENT_EVENT_ABSTRACT);
		createEAttribute(mViewElementEventAbstractEClass, MVIEW_ELEMENT_EVENT_ABSTRACT__TYPE);

		mViewComponentPartEClass = createEClass(MVIEW_COMPONENT_PART);
		createEReference(mViewComponentPartEClass, MVIEW_COMPONENT_PART__MVIEWELEMENTEVENT);

		mViewElementEventEClass = createEClass(MVIEW_ELEMENT_EVENT);

		pinchEventEClass = createEClass(PINCH_EVENT);

		rotateEventEClass = createEClass(ROTATE_EVENT);

		tapEventEClass = createEClass(TAP_EVENT);

		systemEventEClass = createEClass(SYSTEM_EVENT);

		panEventEClass = createEClass(PAN_EVENT);

		touchEventEClass = createEClass(TOUCH_EVENT);

		longPressEventEClass = createEClass(LONG_PRESS_EVENT);
		createEAttribute(longPressEventEClass, LONG_PRESS_EVENT__FINGER_COUNT);
		createEAttribute(longPressEventEClass, LONG_PRESS_EVENT__PRESS_DURATION);

		swipeEventEClass = createEClass(SWIPE_EVENT);
		createEAttribute(swipeEventEClass, SWIPE_EVENT__DIRECTION);

		mActionEventEClass = createEClass(MACTION_EVENT);
		createEAttribute(mActionEventEClass, MACTION_EVENT__EXECUTE_RESULT);

		cameraActionEventEClass = createEClass(CAMERA_ACTION_EVENT);

		microphoneActionEventEClass = createEClass(MICROPHONE_ACTION_EVENT);

		otherActionEventEClass = createEClass(OTHER_ACTION_EVENT);

		mExpressionEClass = createEClass(MEXPRESSION);

		cameraActionEClass = createEClass(CAMERA_ACTION);

		microphoneActionEClass = createEClass(MICROPHONE_ACTION);

		otherActionEClass = createEClass(OTHER_ACTION);

		conditionalExpressionEClass = createEClass(CONDITIONAL_EXPRESSION);
		createEAttribute(conditionalExpressionEClass, CONDITIONAL_EXPRESSION__EXPRESSION);

		staticContentEClass = createEClass(STATIC_CONTENT);
		createEReference(staticContentEClass, STATIC_CONTENT__CONDITIONAL_EXPRESSIONS);
		createEReference(staticContentEClass, STATIC_CONTENT__DOMAIN_CONCEPT);
		createEReference(staticContentEClass, STATIC_CONTENT__ATTRIBUTES);

		dynamicBehaviourEClass = createEClass(DYNAMIC_BEHAVIOUR);
		createEReference(dynamicBehaviourEClass, DYNAMIC_BEHAVIOUR__BEHAVIOUR_CONCEPT);

		contentModelEClass = createEClass(CONTENT_MODEL);
		createEReference(contentModelEClass, CONTENT_MODEL__CONTENT_ELEMENTS);

		contentElementEClass = createEClass(CONTENT_ELEMENT);

		behaviourConceptEClass = createEClass(BEHAVIOUR_CONCEPT);

		domainConceptEClass = createEClass(DOMAIN_CONCEPT);

		featureConceptEClass = createEClass(FEATURE_CONCEPT);

		attributeEClass = createEClass(ATTRIBUTE);
		createEReference(attributeEClass, ATTRIBUTE__FEATURE_CONCEPT);

		// Create enums
		dataTypeEEnum = createEEnum(DATA_TYPE);
		meidaTypeEEnum = createEEnum(MEIDA_TYPE);
		swipeDirectionEEnum = createEEnum(SWIPE_DIRECTION);
		codeTypeEEnum = createEEnum(CODE_TYPE);
		eventTypeEEnum = createEEnum(EVENT_TYPE);
		dirTypeEEnum = createEEnum(DIR_TYPE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		XMLTypePackage theXMLTypePackage = (XMLTypePackage)EPackage.Registry.INSTANCE.getEPackage(XMLTypePackage.eNS_URI);

		// Create type parameters

		// Set bounds for type parameters

		// Add supertypes to classes
		mInteractionFlowEClass.getESuperTypes().add(this.getMUICMElement());
		navigationFlowEClass.getESuperTypes().add(this.getMInteractionFlow());
		dataFlowEClass.getESuperTypes().add(this.getMInteractionFlow());
		mInteractionElementEClass.getESuperTypes().add(this.getMUICMElement());
		dataBindingGroupEClass.getESuperTypes().add(this.getMUICMElement());
		dataBindingEClass.getESuperTypes().add(this.getMUICMElement());
		dataEClass.getESuperTypes().add(this.getMUICMElement());
		mViewElementEClass.getESuperTypes().add(this.getMInteractionElement());
		screenEClass.getESuperTypes().add(this.getMViewElement());
		mviewComponentExtEClass.getESuperTypes().add(this.getMViewElement());
		mViewComponentEClass.getESuperTypes().add(this.getMViewElement());
		searchViewEClass.getESuperTypes().add(this.getMviewComponentExt());
		listEClass.getESuperTypes().add(this.getMviewComponentExt());
		toolBarEClass.getESuperTypes().add(this.getMviewComponentExt());
		formEClass.getESuperTypes().add(this.getMviewComponentExt());
		messageEClass.getESuperTypes().add(this.getMviewComponentExt());
		detailsEClass.getESuperTypes().add(this.getMviewComponentExt());
		utilityViewEClass.getESuperTypes().add(this.getMviewComponentExt());
		mViewComponentPartAbstractEClass.getESuperTypes().add(this.getMInteractionElement());
		fieldEClass.getESuperTypes().add(this.getMViewComponentPartAbstract());
		simpleFieldEClass.getESuperTypes().add(this.getField());
		selectionFieldEClass.getESuperTypes().add(this.getField());
		textBoxEClass.getESuperTypes().add(this.getMViewComponentPartAbstract());
		mediaEClass.getESuperTypes().add(this.getMViewComponentPartAbstract());
		labelEClass.getESuperTypes().add(this.getMViewComponentPartAbstract());
		mActionEClass.getESuperTypes().add(this.getMInteractionElement());
		utilityEClass.getESuperTypes().add(this.getMViewComponentPartAbstract());
		mapEClass.getESuperTypes().add(this.getUtility());
		calendarEClass.getESuperTypes().add(this.getUtility());
		codeEClass.getESuperTypes().add(this.getUtility());
		iconEClass.getESuperTypes().add(this.getMViewComponentPartAbstract());
		contentBindingEClass.getESuperTypes().add(this.getMViewComponentPartAbstract());
		mEventEClass.getESuperTypes().add(this.getMInteractionElement());
		mViewElementEventAbstractEClass.getESuperTypes().add(this.getMEvent());
		mViewComponentPartEClass.getESuperTypes().add(this.getMViewComponentPartAbstract());
		mViewElementEventEClass.getESuperTypes().add(this.getMViewElementEventAbstract());
		pinchEventEClass.getESuperTypes().add(this.getMViewElementEventAbstract());
		rotateEventEClass.getESuperTypes().add(this.getMViewElementEventAbstract());
		tapEventEClass.getESuperTypes().add(this.getMViewElementEventAbstract());
		systemEventEClass.getESuperTypes().add(this.getMViewElementEventAbstract());
		panEventEClass.getESuperTypes().add(this.getMViewElementEventAbstract());
		touchEventEClass.getESuperTypes().add(this.getMViewElementEventAbstract());
		longPressEventEClass.getESuperTypes().add(this.getMViewElementEventAbstract());
		swipeEventEClass.getESuperTypes().add(this.getMViewElementEventAbstract());
		mActionEventEClass.getESuperTypes().add(this.getMEvent());
		cameraActionEventEClass.getESuperTypes().add(this.getMActionEvent());
		microphoneActionEventEClass.getESuperTypes().add(this.getMActionEvent());
		otherActionEventEClass.getESuperTypes().add(this.getMActionEvent());
		mExpressionEClass.getESuperTypes().add(this.getMInteractionElement());
		cameraActionEClass.getESuperTypes().add(this.getMAction());
		microphoneActionEClass.getESuperTypes().add(this.getMAction());
		otherActionEClass.getESuperTypes().add(this.getMAction());
		conditionalExpressionEClass.getESuperTypes().add(this.getMExpression());
		staticContentEClass.getESuperTypes().add(this.getContentBinding());
		dynamicBehaviourEClass.getESuperTypes().add(this.getContentBinding());
		behaviourConceptEClass.getESuperTypes().add(this.getContentElement());
		domainConceptEClass.getESuperTypes().add(this.getContentElement());
		featureConceptEClass.getESuperTypes().add(this.getContentElement());

		// Initialize classes, features, and operations; add parameters
		initEClass(muicmEClass, muicm.MUICM.class, "MUICM", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getMUICM_MuicmElements(), this.getMUICMElement(), null, "muicmElements", null, 0, -1, muicm.MUICM.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getMUICM_Contentmodel(), this.getContentModel(), null, "contentmodel", null, 0, -1, muicm.MUICM.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(muicmElementEClass, MUICMElement.class, "MUICMElement", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getMUICMElement_Name(), ecorePackage.getEString(), "name", null, 0, 1, MUICMElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(mInteractionFlowEClass, MInteractionFlow.class, "MInteractionFlow", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getMInteractionFlow_SourceInteractionElement(), this.getMInteractionElement(), null, "sourceInteractionElement", null, 1, 1, MInteractionFlow.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getMInteractionFlow_TargetInteractionElement(), this.getMInteractionElement(), null, "targetInteractionElement", null, 1, 1, MInteractionFlow.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getMInteractionFlow_DataBindingGroup(), this.getDataBindingGroup(), null, "dataBindingGroup", null, 0, 1, MInteractionFlow.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getMInteractionFlow_SourceElementName(), ecorePackage.getEString(), "sourceElementName", null, 0, 1, MInteractionFlow.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getMInteractionFlow_TargetElementName(), ecorePackage.getEString(), "targetElementName", null, 0, 1, MInteractionFlow.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(navigationFlowEClass, NavigationFlow.class, "NavigationFlow", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(dataFlowEClass, DataFlow.class, "DataFlow", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(mInteractionElementEClass, MInteractionElement.class, "MInteractionElement", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getMInteractionElement_Datas(), this.getData(), null, "datas", null, 0, -1, MInteractionElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(dataBindingGroupEClass, DataBindingGroup.class, "DataBindingGroup", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getDataBindingGroup_DataBindings(), this.getDataBinding(), null, "dataBindings", null, 1, -1, DataBindingGroup.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(dataBindingEClass, DataBinding.class, "DataBinding", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getDataBinding_SourceData(), this.getData(), null, "sourceData", null, 1, 1, DataBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDataBinding_TargetData(), this.getData(), null, "targetData", null, 1, 1, DataBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDataBinding_SourceDataName(), ecorePackage.getEString(), "sourceDataName", null, 0, 1, DataBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDataBinding_TargetDataName(), ecorePackage.getEString(), "targetDataName", null, 0, 1, DataBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(dataEClass, Data.class, "Data", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getData_Type(), this.getDataType(), "type", null, 0, 1, Data.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getData_DirType(), this.getDirType(), "dirType", null, 0, 1, Data.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getData_Visual(), ecorePackage.getEBoolean(), "Visual", "true", 0, 1, Data.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(mViewElementEClass, MViewElement.class, "MViewElement", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getMViewElement_MviewElementEvents(), this.getMViewElementEventAbstract(), null, "mviewElementEvents", null, 0, -1, MViewElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(screenEClass, Screen.class, "Screen", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getScreen_IsModal(), theXMLTypePackage.getBoolean(), "isModal", null, 0, 1, Screen.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getScreen_HasNav(), theXMLTypePackage.getBoolean(), "HasNav", null, 0, 1, Screen.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getScreen_IsHome(), theXMLTypePackage.getBoolean(), "isHome", null, 0, 1, Screen.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getScreen_MviewElements(), this.getMViewElement(), null, "mviewElements", null, 0, -1, Screen.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(mviewComponentExtEClass, MviewComponentExt.class, "MviewComponentExt", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getMviewComponentExt_MviewComponentParts(), this.getMViewComponentPartAbstract(), null, "mviewComponentParts", null, 0, -1, MviewComponentExt.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(mViewComponentEClass, MViewComponent.class, "MViewComponent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getMViewComponent_MviewComponentParts(), this.getMViewComponentPartAbstract(), null, "mviewComponentParts", null, 0, -1, MViewComponent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(searchViewEClass, SearchView.class, "SearchView", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(listEClass, List.class, "List", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(toolBarEClass, ToolBar.class, "ToolBar", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(formEClass, Form.class, "Form", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(messageEClass, Message.class, "Message", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getMessage_Text(), ecorePackage.getEString(), "text", null, 0, 1, Message.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(detailsEClass, Details.class, "Details", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(utilityViewEClass, UtilityView.class, "UtilityView", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(mViewComponentPartAbstractEClass, MViewComponentPartAbstract.class, "MViewComponentPartAbstract", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getMViewComponentPartAbstract_SubMViewComponentPart(), this.getMViewComponentPartAbstract(), null, "subMViewComponentPart", null, 0, -1, MViewComponentPartAbstract.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(fieldEClass, Field.class, "Field", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getField_Content(), ecorePackage.getEString(), "content", null, 0, 1, Field.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(simpleFieldEClass, SimpleField.class, "SimpleField", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(selectionFieldEClass, SelectionField.class, "SelectionField", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getSelectionField_IsMultiSelection(), ecorePackage.getEBoolean(), "isMultiSelection", null, 0, 1, SelectionField.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(textBoxEClass, TextBox.class, "TextBox", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTextBox_Text(), ecorePackage.getEString(), "text", null, 0, 1, TextBox.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(mediaEClass, Media.class, "Media", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getMedia_Type(), this.getMeidaType(), "type", null, 0, 1, Media.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getMedia_MediaImage(), ecorePackage.getEString(), "mediaImage", null, 0, 1, Media.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(labelEClass, Label.class, "Label", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getLabel_Description(), ecorePackage.getEString(), "description", null, 0, 1, Label.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(mActionEClass, MAction.class, "MAction", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getMAction_DynamicBehaviour(), this.getDynamicBehaviour(), null, "dynamicBehaviour", null, 0, 1, MAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getMAction_MactionEvents(), this.getMActionEvent(), null, "mactionEvents", null, 0, -1, MAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(utilityEClass, Utility.class, "Utility", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(mapEClass, Map.class, "Map", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getMap_Provider(), ecorePackage.getEString(), "provider", null, 0, 1, Map.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(calendarEClass, Calendar.class, "Calendar", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCalendar_YearsBlockSize(), ecorePackage.getEInt(), "yearsBlockSize", null, 0, 1, Calendar.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(codeEClass, Code.class, "Code", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCode_Format(), this.getCodeType(), "Format", null, 0, 1, Code.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(iconEClass, Icon.class, "Icon", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(contentBindingEClass, ContentBinding.class, "ContentBinding", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(mEventEClass, MEvent.class, "MEvent", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(mViewElementEventAbstractEClass, MViewElementEventAbstract.class, "MViewElementEventAbstract", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getMViewElementEventAbstract_Type(), this.getEventType(), "type", null, 0, 1, MViewElementEventAbstract.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(mViewComponentPartEClass, MViewComponentPart.class, "MViewComponentPart", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getMViewComponentPart_Mviewelementevent(), this.getMViewElementEvent(), null, "mviewelementevent", null, 0, -1, MViewComponentPart.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(mViewElementEventEClass, MViewElementEvent.class, "MViewElementEvent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(pinchEventEClass, PinchEvent.class, "PinchEvent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(rotateEventEClass, RotateEvent.class, "RotateEvent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(tapEventEClass, TapEvent.class, "TapEvent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(systemEventEClass, SystemEvent.class, "SystemEvent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(panEventEClass, PanEvent.class, "PanEvent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(touchEventEClass, TouchEvent.class, "TouchEvent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(longPressEventEClass, LongPressEvent.class, "LongPressEvent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getLongPressEvent_FingerCount(), theXMLTypePackage.getInt(), "fingerCount", null, 0, 1, LongPressEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getLongPressEvent_PressDuration(), theXMLTypePackage.getFloat(), "pressDuration", "0.3", 0, 1, LongPressEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(swipeEventEClass, SwipeEvent.class, "SwipeEvent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getSwipeEvent_Direction(), this.getSwipeDirection(), "direction", null, 0, 1, SwipeEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(mActionEventEClass, MActionEvent.class, "MActionEvent", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getMActionEvent_ExecuteResult(), ecorePackage.getEBoolean(), "executeResult", null, 0, 1, MActionEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(cameraActionEventEClass, CameraActionEvent.class, "CameraActionEvent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(microphoneActionEventEClass, MicrophoneActionEvent.class, "MicrophoneActionEvent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(otherActionEventEClass, OtherActionEvent.class, "OtherActionEvent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(mExpressionEClass, MExpression.class, "MExpression", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(cameraActionEClass, CameraAction.class, "CameraAction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(microphoneActionEClass, MicrophoneAction.class, "MicrophoneAction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(otherActionEClass, OtherAction.class, "OtherAction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(conditionalExpressionEClass, ConditionalExpression.class, "ConditionalExpression", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getConditionalExpression_Expression(), ecorePackage.getEString(), "expression", null, 0, 1, ConditionalExpression.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(staticContentEClass, StaticContent.class, "StaticContent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getStaticContent_ConditionalExpressions(), this.getConditionalExpression(), null, "conditionalExpressions", null, 0, -1, StaticContent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getStaticContent_DomainConcept(), this.getDomainConcept(), null, "domainConcept", null, 0, 1, StaticContent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getStaticContent_Attributes(), this.getAttribute(), null, "attributes", null, 0, 1, StaticContent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(dynamicBehaviourEClass, DynamicBehaviour.class, "DynamicBehaviour", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getDynamicBehaviour_BehaviourConcept(), this.getBehaviourConcept(), null, "behaviourConcept", null, 0, 1, DynamicBehaviour.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(contentModelEClass, ContentModel.class, "ContentModel", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getContentModel_ContentElements(), this.getContentElement(), null, "contentElements", null, 0, -1, ContentModel.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(contentElementEClass, ContentElement.class, "ContentElement", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(behaviourConceptEClass, BehaviourConcept.class, "BehaviourConcept", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(domainConceptEClass, DomainConcept.class, "DomainConcept", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(featureConceptEClass, FeatureConcept.class, "FeatureConcept", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(attributeEClass, Attribute.class, "Attribute", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getAttribute_FeatureConcept(), this.getFeatureConcept(), null, "featureConcept", null, 0, 1, Attribute.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		// Initialize enums and add enum literals
		initEEnum(dataTypeEEnum, DataType.class, "DataType");
		addEEnumLiteral(dataTypeEEnum, DataType.BOOLEAN);
		addEEnumLiteral(dataTypeEEnum, DataType.CHAR);
		addEEnumLiteral(dataTypeEEnum, DataType.INT);
		addEEnumLiteral(dataTypeEEnum, DataType.DOUBLE);
		addEEnumLiteral(dataTypeEEnum, DataType.DATE);
		addEEnumLiteral(dataTypeEEnum, DataType.STRING);
		addEEnumLiteral(dataTypeEEnum, DataType.OBJECT);
		addEEnumLiteral(dataTypeEEnum, DataType.COLLECTION);

		initEEnum(meidaTypeEEnum, MeidaType.class, "MeidaType");
		addEEnumLiteral(meidaTypeEEnum, MeidaType.IMAGE);
		addEEnumLiteral(meidaTypeEEnum, MeidaType.VEDIO);
		addEEnumLiteral(meidaTypeEEnum, MeidaType.AUDIO);
		addEEnumLiteral(meidaTypeEEnum, MeidaType.OTHER);

		initEEnum(swipeDirectionEEnum, SwipeDirection.class, "SwipeDirection");
		addEEnumLiteral(swipeDirectionEEnum, SwipeDirection.RIGHT);
		addEEnumLiteral(swipeDirectionEEnum, SwipeDirection.LEFT);
		addEEnumLiteral(swipeDirectionEEnum, SwipeDirection.UP);
		addEEnumLiteral(swipeDirectionEEnum, SwipeDirection.DOWN);

		initEEnum(codeTypeEEnum, CodeType.class, "CodeType");
		addEEnumLiteral(codeTypeEEnum, CodeType.QR_CODE);
		addEEnumLiteral(codeTypeEEnum, CodeType.BAR_CODE);

		initEEnum(eventTypeEEnum, EventType.class, "EventType");
		addEEnumLiteral(eventTypeEEnum, EventType.SELECT);
		addEEnumLiteral(eventTypeEEnum, EventType.SUBMIT);
		addEEnumLiteral(eventTypeEEnum, EventType.DELETE);
		addEEnumLiteral(eventTypeEEnum, EventType.BACK);
		addEEnumLiteral(eventTypeEEnum, EventType.NOTIFICATION);
		addEEnumLiteral(eventTypeEEnum, EventType.OTHER);

		initEEnum(dirTypeEEnum, DirType.class, "DirType");
		addEEnumLiteral(dirTypeEEnum, DirType.IN);
		addEEnumLiteral(dirTypeEEnum, DirType.OUT);
		addEEnumLiteral(dirTypeEEnum, DirType.INOUT);

		// Create resource
		createResource(eNS_URI);
	}

} //MuicmPackageImpl
